/*
 * JActualizar.java
 *
 * Created on 12 de septiembre de 2003, 11:54
 */
package ListDatos;

import ListDatos.estructuraBD.*;
import utiles.JDepuracion;

/**
 * Objeto para actualizar un dato 
 */
public final class JActualizar implements IServerEjecutar, java.io.Serializable {
  private static final long serialVersionUID = 3333331L;
  /**
   * Tabla en donde actualizar
   */
  private String msTabla;
  /**
   * Tipo de modificacion (JLisDatos.mclBorrar, mclNuevo, mclEditar)
   */
  private int mlTipoModif;
  /**
   * FieldDefs, Nombre Campos, Tipos, Campos principales y datos
   */
  private JFieldDefs moCampos;
  /**
   *Usuario, Actualmente no se usa
   */
  private final String msUsuario;
  /**
   *PassWord, Actualmente no se usa
   */
  private final String msPassWord;
  /**
   *Permisos, Actualmente no se usa
   */
  private final String msPermisos;
  //indica si es comprimido o no
  private boolean mbComprimido = false;
    private JServerEjecutarParametros moParametros = new JServerEjecutarParametros();

    /**
    * Constructor de JActualizar 
    * @param poCampos Lista de FieldsDef
    * @param psTabla Tabla a actualizar
    * @param plTipoModif Tipo de modificacion JListDatos.mclBorrar, JListDatos.mclEditar, JListDatos.mclNuevo 
    * @param psUsuario usuario, generalmente es a nulo
    * @param psPassWord password, generalmente es a nulo
    * @param psPermisos permisos, generalmente es a nulo
    */
    public JActualizar(final JFieldDefs poCampos, final String psTabla, final int plTipoModif, final String psUsuario, final String psPassWord, final String psPermisos) {
        super();
        msUsuario=psUsuario;
        msPassWord=psPassWord;
        msPermisos=psPermisos;
        moCampos = poCampos;
        msTabla = psTabla;
        mlTipoModif = plTipoModif;
    }
    /**
    * Constructor de JActualizar
    * @param psUsuario usuario, generalmente es a nulo
    * @param psPassWord password, generalmente es a nulo
    * @param psPermisos permisos, generalmente es a nulo
    */
    public JActualizar(final String psUsuario, final String psPassWord, final String psPermisos) {
        super();
        msUsuario=psUsuario;
        msPassWord=psPassWord;
        msPermisos=psPermisos;
    }
    /**
     * Devuelve una SQL de actualizacion en funcion de ISelect 
     * @return sql
     * @param poSelect select
     */
    public String msSQL(final ISelectMotor poSelect){
        String lsResult;
//        if(mlTipoModif == JListDatos.mclCrearTabla){
//            lsResult=poSelect.crearTabla(msTabla, moCampos);
//        }else{
            lsResult=poSelect.msActualizacion(msTabla, moCampos, mlTipoModif);
//        }
        return lsResult;
    }
    
   /**
   *Password, Actualmente no se usa
   */
   public String getPassWord() {
        return msPassWord;
    }
  
    public String getPermisos() {
        return msPermisos;
    }

    public String getUsuario() {
        return msUsuario;
    }
    /**
     * Devuelve el tipo actualizacion 
     * @return tipo modif.
     */
    public int getTipoModif(){
        return mlTipoModif;
    }
    /**
     * Devuelve la tabla 
     * @return tabla
     */
    public String getTabla(){
        return msTabla;
    }
    /**
     * Devuelve el script
     * @return script
     */
    public String getScript(){
        return msTabla;
    }
    
    /**
     * Devuelve los campos 
     * @return campos
     */
    public JFieldDefs getFields(){
        return moCampos;
    }

    /**
     * Devuelve el tipo actualizacion 
     * @param plTipoModif tipo modif.
     */
    public void setTipoModif(final int plTipoModif){
        mlTipoModif = plTipoModif;
    }
    /**
     * Devuelve la tabla
     * @param psTabla tabla
     */
    public void setTabla(final String psTabla){
        msTabla = psTabla;
    }
    /**
     * Establece el script
     * @param psScript script
     */
    public void setScript(final String psScript){
        msTabla = psScript;
        setFields(new JFieldDefs());
    }
    /**
     * Establece los campos
     * @param poCampos campos
     */
    public void setFields(final JFieldDefs poCampos){
        moCampos = poCampos;
    }
    /**Devuelve el objeto en cadena*/
    public String toString(){
        return msSQL(JSelectMotorFactory.getInstance().getSelectMotorDefecto());
    }
    public String getXML() {
        return msSQL(new JXMLSelectMotor());
    }

    public void setComprimido(final boolean pbValor) {
      mbComprimido = pbValor;
    }
    
    public boolean getComprimido() {
      return mbComprimido;
    }

    public IResultado ejecutar(final IServerServidorDatos poServer) throws Exception {
        return poServer.actualizar("", this);
    }

    public JServerEjecutarParametros getParametros() {
        return moParametros;
    }

    
 
}
