
package ListDatos;

import utiles.*;

/**
 * Implementa un iteracion sobre las filas del JListDatos 
 */
public final class JListDatosIterator implements IListaElementosIterator {
  private static final long serialVersionUID = 33333310L;
  private final JListDatos moList;
  private boolean mbFin = false;
  private boolean mbPrimero = true;
  /**
   * Constructor
   * @param poList JListDatos a iterar
   */
  public JListDatosIterator(final JListDatos  poList) {
    moList = poList;
    mbFin = !moList.moveFirst();
  }
  /**
   * Devuelve si quedan pedientes de procesar
   * @return si quedan
   */
  public boolean hasNext() {
    return !mbFin;
  }
  /**
   * Devuelve siguiente objeto de la lista
   * @return objeto
   */
  public Object next() {
    if(mbPrimero) {
        mbPrimero=false;
        mbFin = mbFin || moList.mbEsElUltimo();
    } else{
        moList.moveNext();
        mbFin = mbFin || moList.mbEsElUltimo();
    }
    return moList.get(moList.getIndex());
  }
  /**borra el objeto actual*/
  public void remove() {
    throw new java.lang.InternalError("Method remove() not yet implemented.");
  }
}