/*
 * JListDatosMemento.java
 *
 * Created on 21 de septiembre de 2003, 10:38
 */

package ListDatos;

import java.io.Serializable;

/**
 * Almacena el estado completo del JListDatos, sirve para restaurar el estado completamente
 */
public final class JListDatosMemento implements Serializable {
    private static final long serialVersionUID = 1L;
    
    private final int mlModo;
    private final IFilaDatos moFila;
    
    public JListDatosMemento() {
        this(-1, null);
    }
    
    /**
     * Crea una nueva instancia de JListDatosMemento 
     * @param plModo modo del JListDatos(Edicion, nuevo)
     * @param poFila Datos de la fila actual
     */
    public JListDatosMemento(final int plModo, final IFilaDatos poFila) {
        mlModo = plModo;
        moFila = poFila;
    }
    void establecerEstado(final JListDatos poList){
      poList.setModoTabla(getModo());
      switch(getModo()){
          case JListDatos.mclNuevo:
              poList.addNew();
              poList.cargarFields(getFila());
              break;
          default:
              int[] lalCamposPrincipales = poList.getFields().malCamposPrincipales();
              if(lalCamposPrincipales!=null){
                  String[] lasCadenas = new String[lalCamposPrincipales.length];
                  for(int i = 0; i < lalCamposPrincipales.length ; i++){
                      lasCadenas[i] = getFila().msCampo(lalCamposPrincipales[i]);
                  }
                  if (poList.buscar(JListDatos.mclTIgual, lalCamposPrincipales, lasCadenas, false)){
                      poList.cargarFields(getFila());
                  }else{
                      poList.setModoTabla(JListDatos.mclNada);
                  }
                  lasCadenas=null;
              }
      }
        
    }

    /**
     * @return the mlModo
     */
    public int getModo() {
        return mlModo;
    }

    /**
     * @return the moFila
     */
    public IFilaDatos getFila() {
        return moFila;
    }
    
}
