/*
 * JServidorDatos.java
 *
 * Created on 16 de enero de 2007, 11:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ListDatos;

import ListDatos.estructuraBD.*;
//entrada por fichero y web
import java.io.*;

public class JServerServidorDatosFichero extends JServidorDatosAbtrac {

    /**url base*/
    private String msURLBase1;

    private char mcCaracterSepacion = JFilaDatosDefecto.mccSeparacion1;
    private boolean mbCabezera = false;
    /** Creates a new instance of ServidorDatos */
    public JServerServidorDatosFichero() {
        super();
        msURLBase1="";
    }
    
    /**
     * Crea una instancia de servidor de datos con una URL fija
     * @param psURLBase url base
     * @param pcCaracterSeparacion Caracter d eseparacion
     */
    public JServerServidorDatosFichero(final String psRuta, final char pcCaracterSeparacion, final boolean pbCabezera) {
        super();
        msURLBase1=psRuta;
        mcCaracterSepacion = pcCaracterSeparacion;
        mbCabezera = pbCabezera;
        utiles.JDepuracion.anadirTexto(utiles.JDepuracion.mclINFORMACION,this.getClass().getName(),"Inicializado");
    }
    public ISelectMotor getSelect() {
        return null;
    }
    
    /**
     * establece la url base
     * @param psURLBase url
     */
    public void setURLBase1(final String psURLBase){
      msURLBase1 = psURLBase;
    }
    /**
     * devuelve la url base
     * @return url
     */
    public String getURLBase1(){
        return msURLBase1;
    }
    /**
     * establece el usuario no se usa
     * @param psUsuario usuario
     * @param psPassword password
     * @param psPermisos permisos
     */
    public void setUsuario(final String psUsuario,final String psPassword,final String psPermisos){
      msUsuario=psUsuario;
      msPassWord=psPassword;
      msPermisos=psPermisos;
    }
    /**
     * devuelve el usuario no se usa
     * @return usuario
     */
    public String getUsuario(){
      return msUsuario;
    }

    ////////////////////////////////////////77
    ////Actualizaciones y sincronizacion fisica
    //////////////////////////////////////////
    public JTableDefs getTableDefs() throws Exception {
        return null;
    }
    public IResultado modificarEstructura(final ISelectEjecutarSelect poEstruc) {
        
        return new JResultado(new JFilaDatosDefecto(), "", "No implementado", false, 0);
    }
    public IResultado ejecutarServer(final IServerEjecutar poEjecutar){
        return new JResultado(new JFilaDatosDefecto(), "", "No implementado", false, 0);
    }
    
    protected void recuperarInformacion(final JListDatos v, final JSelect poSelect, final String psTabla) throws Exception{
        //introduccion de campos a la select de sistema
        poSelect.setPassWord(msPassWord);
        poSelect.setPermisos(msPermisos);
        poSelect.setUsuario(msUsuario);
        //recuperacion de datos fisica
        recuperarDatosFichero(v, poSelect ,psTabla);
    }
    public File getTablaFichero(String psTabla){
        if(msURLBase1 == null || msURLBase1.equals("")){
            return new File(psTabla);
        }else{
            return new File(msURLBase1, psTabla);
        }
    }
    public JListDatos recuperarDatosFichero(final JListDatos v,final InputStream miFStream, JListDatosFiltroConj loFiltro, final String psTabla) throws Exception  {
        BufferedReader miDStream=null;
	
        try{
            miDStream = new BufferedReader(new InputStreamReader(miFStream));

            //cuando sea el resultado vacio
            String inputLine= miDStream.readLine();
            //si hay cabezera nos la saltamos
            if(mbCabezera){
                inputLine= miDStream.readLine();
            }
            while (inputLine != null){
                if(inputLine.length()>0){
                    if(inputLine.charAt(inputLine.length()-1) != mcCaracterSepacion){
                       inputLine += mcCaracterSepacion;
                    }
                }else{
                    inputLine += mcCaracterSepacion;
                }
                IFilaDatos loFila = JFilaCrearDefecto.getFilaCrear().getFilaDatos(psTabla);
                loFila.setArray(JFilaDatosDefecto.moArrayDatos(inputLine, mcCaracterSepacion));
                if (loFiltro.mbCumpleFiltro(loFila)) {
                    v.add(loFila);
                }
                inputLine= miDStream.readLine();
            }

            return v;
        }finally{
            if(miDStream!=null){
                miDStream.close();
            }
        }
    }
    private JListDatos recuperarDatosFichero(final JListDatos v,final JSelect poSelect,final String psTabla) throws Exception  {
        InputStream miFStream=null;
	
        try{
            File loFile = getTablaFichero(psTabla);
            if(loFile.exists()){
                miFStream = new FileInputStream(loFile);
            }else{
                 miFStream=getClass().getResourceAsStream(msURLBase1 + psTabla);
            }
            return recuperarDatosFichero(v, miFStream, poSelect.getWhere(), psTabla);
        }finally{
            if(miFStream!=null){
                miFStream.close();
            }
        }
    }

    public void guardar(final JListDatos v) throws Exception{

        //creamos el directorio
        File loFile = new File(msURLBase1);
        loFile.mkdir();
        loFile = new File(loFile.getAbsolutePath(), v.msTabla);
        if(loFile.exists()){
            loFile.delete();
        }
        //creamos el ficheor con los datros de la tabla
        PrintWriter out =
                new PrintWriter(
                    new FileOutputStream(loFile));

        StringBuffer lasBuffer;
        if(mbCabezera){
            lasBuffer = new StringBuffer(v.getFields().size()*8);
            for(int i = 0 ; i < v.getFields().size(); i++){
                lasBuffer.append(v.getFields(i).getNombre());
                lasBuffer.append(mcCaracterSepacion);
            }
            out.println(lasBuffer.toString());
        }
        if (v.moveFirst()){
            do{
                lasBuffer = new StringBuffer(v.getFields().size()*8);
                for(int i = 0 ; i < v.getFields().size(); i++){
                    lasBuffer.append(v.getFields(i).toString());
                    lasBuffer.append(mcCaracterSepacion);
                }
                out.println(lasBuffer.toString());
            }while(v.moveNext());
        }
        out.close();
    }
    /**
     *
     * cerrar objeto, si es tipo base de datos es muy importante hacerlo
     * @throws Exception el error en caso de error
     */
    public void close() throws Exception{
    }

    public IResultado actualizar(String psSelect, JActualizar poActualizar) {
        throw new RuntimeException("Not supported yet.");
    }

}
