/*
 * IListaElementos.java
 *
 * Created on 13 de enero de 2005, 19:38
 */

package utiles;

import java.io.Serializable;
/**Interfaz que cumple las lista de elementos*/
public interface IListaElementos extends Serializable, Cloneable {
    /**
     * anade un elemento
     * @return si ha tenido exito
     * @param poFilaDatos dato
     */
    public boolean add(Object poFilaDatos);
    /**
     * devuelve el numero de datos
     * @return numero de elementos
     */
    public int size();
    /**
     * Devuelve el elemento de la posicion dada
     * @return objeto
     * @param i index
     */
    public Object get(int i);
    /**
     * borramos el elemento de la posicion index
     * @return objeto borrado
     * @param index indice
     */
    public Object remove(int index);
    /**
     * borramos el elemento
     * @return objeto borrado
     * @param poObject objeto a borrar
     */
    public Object remove(Object poObject);
    /**borramos todos los elementos*/
    public void clear();
    /**
     * devuelve un iterador de esta coleccion
     * @return iterador
     */
    public IListaElementosIterator iterator();
}
