/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utiles.cuadernos.q58y19;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import utiles.JConversiones;
import utiles.JFormat;

public class JCuardernoExportar {
    private JCuaderno58y19 moCuaderno;
    private String msFichero;

    public JCuardernoExportar(){
    }

    public void setFichero(String psFichero){
        msFichero=psFichero;
    }
    public void setCuaderno(JCuaderno58y19 poCuaderno){
        moCuaderno=poCuaderno;
    }

    public void exportar() throws  Throwable {
        PrintWriter loPrint =new PrintWriter(new FileOutputStream(msFichero));
        try{
            exportar(loPrint, moCuaderno.getPresentador());
            for(int i = 0 ; i < moCuaderno.getOrdenantes().size();i++){
                JCuadernoOrdenante loORD = (JCuadernoOrdenante) moCuaderno.getOrdenantes().get(i);
                exportar(loPrint, loORD);
                for(int l = 0 ; l < loORD.getIndividuales().size();l++){
                    JCuadernoIndividual loIND = (JCuadernoIndividual) loORD.getIndividuales().get(l);
                    exportar(loPrint, loORD, loIND);
                }
                exportar(loPrint,loORD, loORD.getTotal());
            }
            exportar(loPrint, moCuaderno.getPresentador(), moCuaderno.getTotal());
        }finally{
            if(loPrint!=null){
                loPrint.close();
            }
        }

    }

    private void exportar(PrintWriter poPrint, JCuadernoPresentador poPresentador) throws Exception{
        StringBuffer loBuffer = new StringBuffer(162);
        if(poPresentador.getCCC() ==null ||
           poPresentador.getCCC().length()<8 ||
           !JConversiones.isNumeric(poPresentador.getCCC().substring(0, 8) )){
            throw new Exception("CCC del presentador incorrecta");
        }
        loBuffer.append(JFormat.msFormatearDouble(poPresentador.getCodReg(), "00"));
        loBuffer.append(JFormat.msFormatearDouble(poPresentador.getCodDato(), "00"));
        loBuffer.append(JFormat.msRellenarIzq(poPresentador.getNifPresen().toUpperCase(), "0", 9));
        loBuffer.append(JFormat.msRellenarIzq(poPresentador.getSufijoPresen().toUpperCase(), "0", 3));
        loBuffer.append(poPresentador.getFechaConcepcion().msFormatear("ddMMyy"));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 6));
        loBuffer.append(JFormat.msRellenarDer(poPresentador.getNombrePresentador().toUpperCase(), " " , 40));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 20));
        loBuffer.append(JFormat.msRellenarIzq(poPresentador.getCCC().toUpperCase(),"0",8));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 12));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 40));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 14));

        poPrint.println(loBuffer.toString());
        if(loBuffer.toString().length()!=162){
            throw new Exception("Long. del registro del presentador " + String.valueOf(loBuffer.length()) + " y debera ser 162");
        }
    }
    private void exportar(PrintWriter poPrint, JCuadernoOrdenante poOrdenante) throws Exception{
        StringBuffer loBuffer = new StringBuffer(162);
        if(!JConversiones.isNumeric(poOrdenante.getCCC())){
            throw new Exception("CCC del ordenante incorrecta");
        }
        if(poOrdenante.getNombreOrdenante()==null || poOrdenante.getNombreOrdenante().equals("")){
            throw new Exception("Nombre del ordenante vaco");
        }
        loBuffer.append(JFormat.msFormatearDouble(poOrdenante.getCodReg(), "00"));
        loBuffer.append(JFormat.msFormatearDouble(poOrdenante.getCodDato(), "00"));
        loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getNifOrden().toUpperCase(), "0", 9));
        loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getSufijoOrden().toUpperCase(), "0", 3));
        loBuffer.append(poOrdenante.getFechaConcepcion().msFormatear("ddMMyy"));
        if(moCuaderno.is58()){
            loBuffer.append(JFormat.msRellenarIzq("", " ", 6));
        }else{
            loBuffer.append(poOrdenante.getFechaCargo().msFormatear("ddMMyy"));
        }

        loBuffer.append(JFormat.msRellenarDer(poOrdenante.getNombreOrdenante().toUpperCase(), " " , 40));
        loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getCCC(),"0",20));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 8));
        loBuffer.append(JFormat.msFormatearDouble(poOrdenante.getProcedimiento(), "00"));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 10));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 40));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 2));
        if(moCuaderno.is58()){
            loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getCodigoIne(), "0", 9));
        }else{
            loBuffer.append(JFormat.msRellenarIzq("", " ", 9));
        }
        loBuffer.append(JFormat.msRellenarIzq("", " ", 3));


        poPrint.println(loBuffer.toString());
        if(loBuffer.length()!=162){
            throw new Exception("Long. del registro del ordenante " + String.valueOf(loBuffer.length()) + " y debera ser 162");
        }
    }
    private String getQuitarCaracterPuntoOComa(String psCadena){
        StringBuffer ls = new StringBuffer(psCadena.length()-1);
        for(int i = 0 ; i < psCadena.length() ; i++){
            if(psCadena.charAt(i)!='.' && psCadena.charAt(i)!=',' ){
                ls.append(psCadena.charAt(i));
            }
        }
        return ls.toString();
    }
    private void exportar(PrintWriter poPrint, JCuadernoOrdenante poOrdenante, JCuadernoIndividual poIndividual) throws Exception{
        StringBuffer loBuffer = new StringBuffer(162);

        if(poIndividual.getNombreTitularCredito()==null || poIndividual.getNombreTitularCredito().equals("")){
            throw new Exception("Nombre del titular del registro individual vaco");
        }
        loBuffer.append(JFormat.msFormatearDouble(poIndividual.getCodReg(), "00"));
        loBuffer.append(JFormat.msFormatearDouble(poIndividual.getCodDato(), "00"));
        loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getNifOrden().toUpperCase(), "0", 9));
        loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getSufijoOrden().toUpperCase(), "0", 3));
        loBuffer.append(JFormat.msRellenarDer(poIndividual.getCodigoReferenciaCliente().toUpperCase(), " ", 12));
        loBuffer.append(JFormat.msRellenarDer(poIndividual.getNombreTitularCredito().toUpperCase(), " ", 40) );
        loBuffer.append(JFormat.msRellenarIzq(poIndividual.getCCCAdeudo(),"0",20));
        loBuffer.append(getQuitarCaracterPuntoOComa(JFormat.msFormatearDouble(poIndividual.getImporte(), "00000000.00")));
//        loBuffer.deleteCharAt(loBuffer.length()-3);//borramos el punto o coma
        loBuffer.append(JFormat.msRellenarDer(poIndividual.getCodigoParaDevoluciones()," ",6));
        loBuffer.append(JFormat.msRellenarDer(poIndividual.getCodigoParaDevolucionesReferenciaInterna()," ",10));
        loBuffer.append(JFormat.msRellenarDer(poIndividual.getConcepto1().toUpperCase(), " ", 40));
        if(moCuaderno.is58()){
            loBuffer.append(poIndividual.getFechaVencimiento().msFormatear("ddMMyy"));
        }else{
            loBuffer.append(JFormat.msRellenarIzq("", " ", 6));
        }
        loBuffer.append(JFormat.msRellenarIzq("", " ", 2));


        poPrint.println(loBuffer.toString());
        if(loBuffer.length()!=162){
            throw new Exception("Long. del registro del individual " + String.valueOf(loBuffer.length()) + " y debera ser 162 de referencia " + poIndividual.getCodigoParaDevoluciones());
        }

        if(poIndividual.hayRegistroDomicilio()){
            loBuffer = new StringBuffer(162);

            loBuffer.append(JFormat.msFormatearDouble(poIndividual.getCodReg(), "00"));
            loBuffer.append(JFormat.msFormatearDouble(poIndividual.getCodDatoDom(), "00"));
            loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getNifOrden().toUpperCase(), "0", 9));
            loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getSufijoOrden().toUpperCase(), "0", 3));
            loBuffer.append(JFormat.msRellenarDer(poIndividual.getCodigoReferenciaCliente().toUpperCase(), " ", 12));
            if(moCuaderno.is58()){
                loBuffer.append(JFormat.msRellenarDer(poIndividual.getDomicilioDeudor().toUpperCase(), " ", 40) );
                loBuffer.append(JFormat.msRellenarIzq(poIndividual.getPlazaDomicilioDeudor().toUpperCase()," ",35));
                loBuffer.append(JFormat.msRellenarIzq(poIndividual.getCPDeudor(),"0",5));
                loBuffer.append(JFormat.msRellenarIzq(poIndividual.getLocalidadOrdenante().toUpperCase()," ",38));
                loBuffer.append(JFormat.msRellenarIzq(poIndividual.getCodProvinciaOrdenante().toUpperCase(),"0",2));
                if(poIndividual.getFechaOrigen()!=null){
                    loBuffer.append(poIndividual.getFechaOrigen().msFormatear("ddMMyy") );
                }else{
                    loBuffer.append(poOrdenante.getFechaConcepcion().msFormatear("ddMMyy") );
                }
                loBuffer.append(JFormat.msRellenarIzq("", " ", 8));
            }else{
                loBuffer.append(JFormat.msRellenarDer(poIndividual.getNombreTitularCredito().toUpperCase(), " ", 40) );
                loBuffer.append(JFormat.msRellenarDer(poIndividual.getDomicilioDeudor().toUpperCase(), " ", 40) );
                loBuffer.append(JFormat.msRellenarIzq(poIndividual.getPlazaDomicilioDeudor().toUpperCase()," ",35));
                loBuffer.append(JFormat.msRellenarIzq(poIndividual.getCPDeudor(),"0",5));
                loBuffer.append(JFormat.msRellenarIzq("", " ", 14));
            }


            poPrint.println(loBuffer.toString());
            if(loBuffer.length()!=162){
                throw new Exception("Long. del registro del individual opcional direccin " + String.valueOf(loBuffer.length()) + " y debera ser 162");
            }
            
        }
    }
    private void exportar(PrintWriter poPrint, JCuadernoOrdenante poOrdenante, JCuadernoTotalOrdenante poTotalOrd) throws Exception{
        StringBuffer loBuffer = new StringBuffer(162);

        loBuffer.append(JFormat.msFormatearDouble(poTotalOrd.getCodReg(), "00"));
        loBuffer.append(JFormat.msFormatearDouble(poTotalOrd.getCodDato(), "00"));
        loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getNifOrden().toUpperCase(), "0", 9));
        loBuffer.append(JFormat.msRellenarIzq(poOrdenante.getSufijoOrden().toUpperCase(), "0", 3));
        loBuffer.append(JFormat.msRellenarDer("", " ", 12));
        loBuffer.append(JFormat.msRellenarDer("", " ", 40) );
        loBuffer.append(JFormat.msRellenarIzq(""," ",20));
        loBuffer.append(getQuitarCaracterPuntoOComa(JFormat.msFormatearDouble(poTotalOrd.getSuma(), "00000000.00")));
//        loBuffer.deleteCharAt(loBuffer.length()-3);//borramos el punto o coma
        loBuffer.append(JFormat.msRellenarDer("", " ", 6) );
        loBuffer.append(JFormat.msRellenarIzq(String.valueOf(poTotalOrd.getNumeroIndividuales()),"0",10));
        loBuffer.append(JFormat.msRellenarIzq(String.valueOf(poTotalOrd.getNumeroRegistros()),"0",10));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 20));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 18));


        poPrint.println(loBuffer.toString());
        if(loBuffer.length()!=162){
            throw new Exception("Long. del registro del total ordenante " + String.valueOf(loBuffer.length()) + " y debera ser 162");
        }
    }

    private void exportar(PrintWriter poPrint, JCuadernoPresentador poPresen, JCuadernoTotal poTotal) throws Exception{
        StringBuffer loBuffer = new StringBuffer(162);

        loBuffer.append(JFormat.msFormatearDouble(poTotal.getCodReg(), "00"));
        loBuffer.append(JFormat.msFormatearDouble(poTotal.getCodDato(), "00"));
        loBuffer.append(JFormat.msRellenarIzq(poPresen.getNifPresen().toUpperCase(), "0", 9));
        loBuffer.append(JFormat.msRellenarIzq(poPresen.getSufijoPresen().toUpperCase(), "0", 3));
        loBuffer.append(JFormat.msRellenarDer("", " ", 12));
        loBuffer.append(JFormat.msRellenarDer("", " ", 40) );
        loBuffer.append(JFormat.msRellenarIzq(String.valueOf(poTotal.getNumeroOrdenantesDiferentes()),"0",4));
        loBuffer.append(JFormat.msRellenarIzq(""," ",16));
        loBuffer.append(getQuitarCaracterPuntoOComa(JFormat.msFormatearDouble(poTotal.getSuma(), "00000000.00")));
//        loBuffer.deleteCharAt(loBuffer.length()-3);//borramos el punto o coma
        loBuffer.append(JFormat.msRellenarDer("", " ", 6) );
        loBuffer.append(JFormat.msRellenarIzq(String.valueOf(poTotal.getNumeroIndividuales()),"0",10));
        loBuffer.append(JFormat.msRellenarIzq(String.valueOf(poTotal.getNumeroRegistros()),"0",10));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 20));
        loBuffer.append(JFormat.msRellenarIzq("", " ", 18));


        poPrint.println(loBuffer.toString());
        if(loBuffer.length()!=162){
            throw new Exception("Long. del registro del total presentador " + String.valueOf(loBuffer.length()) + " y debera ser 162");
        }
    }

}
