/*
 * JAccionDevolver.java
 *
 * Created on 22 de noviembre de 2004, 8:41
 */

package utilesBD.servletAcciones;

import ListDatos.IServerServidorDatos;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import utiles.config.JDatosGeneralesXML;
import utilesBD.poolConexiones.PoolObjetos;
public class JAccionDevolver implements IAccionDevolver {
    private static final long serialVersionUID = 33333353L;
    
    public void inicializar(ServletContext context) throws Throwable {
        JDatosGeneralesXML loDatosGeneralesXML =  (JDatosGeneralesXML) context.getAttribute(JDatosGeneralesXML.class.getName());
        PoolObjetos.inicializar(loDatosGeneralesXML);
    }
    
    public IAccion getAccion(String psAccion, String psDir) {
        IAccion loAccion = null;
        String lsAccion = psAccion.toLowerCase();
        if(lsAccion.equalsIgnoreCase("selectdatos")){
            loAccion = new ASelectDatos();
        }
        if(lsAccion.equalsIgnoreCase("guardardatos")){
            loAccion = new AGuardarDatos(psDir);
        }
        if(lsAccion.equalsIgnoreCase("entradacomprimida")){
            loAccion = new AEntradaComprimida();
        }
        if(lsAccion.equalsIgnoreCase(AListaPropiedadesHTTP.mcslistaFicherosPropiedades)){
            loAccion = new AListaPropiedadesHTTP(psDir);
        }
        return loAccion;
    }

    public IServerServidorDatos getServidor(boolean pbEdicion) throws Throwable {
        return PoolObjetos.getServidorDatos(pbEdicion);
    }

    public void aplicarFiltros(IServerServidorDatos poServer, boolean pbEdicion, HttpServletRequest request, HttpServletResponse response, ServletContext poServletContext, Usuario poUsuario) throws Throwable {
    }

    public void desAplicarFiltros(IServerServidorDatos poServer, boolean pbEdicion, HttpServletRequest request, HttpServletResponse response, ServletContext poServletContext, Usuario poUsuario) throws Throwable {
        poServer.borrarFiltrosTodos();
    }

    public void terminar(ServletContext context) throws Throwable {
        PoolObjetos.close();
    }
    
}

