/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
 
package utilesGUIx.configForm;

import ListDatos.IFilaDatos;
import ListDatos.JListDatos;
import utiles.config.JDatosGeneralesXML;
import utilesGUIx.formsGenericos.IMostrarPantalla;

import utilesGUIx.formsGenericos.JPanelGeneralBotones;
import utilesGUIx.formsGenericos.JT2GENERALBASEModelo;
import utilesGUIx.formsGenericos.busqueda.IConsulta;

public class JT2CONEXIONESModelo extends JT2GENERALBASEModelo {
    private static final String mcsProbar = "Probar";

    private final JTFORMCONEXIONES moConsulta;
    private final IMostrarPantalla moMostrarPantalla;

    private JConexionLista moListaConex;
    private JConexionIO moIO;
    private final ICONEXIONESMostrar moConexMostrar;

    /** Crea una nueva instancia de JT2ATRIBUTOSDEF */
    public JT2CONEXIONESModelo(final JDatosGeneralesXML poDatosGeneralesXML, final IMostrarPantalla poMostrarPantalla, final ICONEXIONESMostrar poConexMostrar) throws Exception {
        super();
        moMostrarPantalla = poMostrarPantalla;
        moIO = new JConexionIO();
        moIO.setLector(poDatosGeneralesXML);
        moListaConex = moIO.leerListaConexiones();
        moConsulta = new JTFORMCONEXIONES(moListaConex);
        addBotones();
        getParametros().setLongitudCampos(getLongitudCampos());
        getParametros().setPlugInPasados(true);
        moConexMostrar=poConexMostrar;
    }

    public IConsulta getConsulta() {
        return moConsulta;
    }

    public void mostrarFormPrinci() throws Exception {
        moMostrarPantalla.mostrarFormPrinci(this, 800,600, 1, IMostrarPantalla.mclEdicionDialog);
        moIO.guardarListaConexiones(moListaConex);

    }

    public void anadir() throws Exception {
        JConexion loConex = new JConexion();
        
        moConexMostrar.mostrar(loConex, this, moMostrarPantalla);
    }

    public void borrar(final int plIndex) throws Exception {
        moConsulta.moList.setIndex(plIndex);

        moListaConex.delete(moConsulta.getList().getFields(moConsulta.lPosiNombre).getString());

        IFilaDatos loFila = (IFilaDatos) moConsulta.moList.moFila().clone();
        loFila.setTipoModif (JListDatos.mclBorrar);
        datosactualizados(loFila);
    }

    public void editar(final int plIndex) throws Exception {
        moConsulta.moList.setIndex(plIndex);

        JConexion loConex = moListaConex.get(moConsulta.getList().getFields(moConsulta.lPosiNombre).getString());
        loConex.leerConfig();
        moConexMostrar.mostrar(loConex, this, moMostrarPantalla);
    }
    void addConexion(JConexion poConexion) throws Exception {
        //transformamos en ifila
        IFilaDatos loFila = JTFORMCONEXIONES.getFilaDeConex(poConexion);
        //conexigomos la conexion previa
        JConexion loAux = moListaConex.get(poConexion.getNombre());

        if(loAux==null){
            //si no existe es nuevo
            loFila.setTipoModif(JListDatos.mclNuevo);
        }else{
            //si existe es editar y se borra
            loFila.setTipoModif(JListDatos.mclEditar);
            moListaConex.delete(poConexion.getNombre());
        }
        //se aade la conexion
        moListaConex.add(poConexion);
        //actualizamos datos de la tabla
        datosactualizados(loFila);
    }

    public String getNombre() {
        return "Conexiones";
    }

    public int[] getLongitudCampos() {
        int[] loInt = new int[JTFORMCONEXIONES.mclNumeroCampos];
        loInt[JTFORMCONEXIONES.lPosiNombre ]=80;
        loInt[JTFORMCONEXIONES.lPosiTipo]=80;
        return loInt;
    }

    public void actionPerformed(utilesGUIx.ActionEventCZ e, int[] plIndex) throws Exception {
            if(plIndex.length>0){
                if(e.getActionCommand().equals(mcsProbar)){
                    for(int i = 0 ; i < plIndex.length; i++){
                        moConsulta.moList.setIndex(plIndex[i]);
                        JConexion loConex = moListaConex.get(moConsulta.getList().getFields(moConsulta.lPosiNombre).getString());
                        loConex.probar();
                    }
                    moMostrarPantalla.mensaje(null, "Conexiones probadas correctamente", IMostrarPantalla.mclMensajeInformacion, null);
                }
            }else{
                throw new Exception("No existe una fila actual");
            }
    }


    public void addBotones() {
        JPanelGeneralBotones retValue;

        retValue = getParametros().getBotonesGenerales();

//        retValue.addBotonPrincipal(new JBotonRelacionado(mcsProbar, mcsProbar, "", this));

    }

    public void datosactualizados(IFilaDatos poFila) throws Exception {
        super.datosactualizados(poFila);
    }


}
