/*
 * JPersonalizacionTabla.java
 *
 * Created on 1 de diciembre de 2006, 14:04
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package utilesGUIx.formsGenericos;

import java.io.FileNotFoundException;
import java.io.IOException;
import utiles.JDepuracion;
import utilesGUIx.JGUIxConfigGlobalModelo;

public abstract class JTablaConfigAbstract implements ITablaConfig{
    public static final String mcsNombreDefecto = "Defecto";
    
    protected static JTablaConfigTablas moConfigTablas = null;
    protected JTablaConfigTabla moTablaConfig;
    protected JTablaConfigTablaConfig moTablaConfigConcreta;
    protected int[] malLong = null;
    protected int[] malOrden = null;
    protected boolean[] mabVisible = null;
    protected boolean mbAnularEventos = false;
    protected boolean mbInicializado = false;

    /** Creates a new instance of JPersonalizacionTabla */
    public JTablaConfigAbstract() {
        super();
    }
    
    public void setInicializado(boolean pbIni) {
        mbInicializado = pbIni;
    }

    /** Creates a new instance of JPersonalizacionTabla */
    public void setDatos(
            final String psNombre, final int[] palLong, final int[] palOrden,
            boolean[] pabVisible) {
//        System.out.println("setDatos");
        mbInicializado = true;
        malLong = palLong;
        malOrden = palOrden;
        mabVisible = pabVisible;
        moTablaConfig = getConfigTablas().getTabla(psNombre);
        if (moTablaConfig == null) {
            moTablaConfig = new JTablaConfigTabla();
            moTablaConfig.setNombre(psNombre);
            getConfigTablas().addTabla(moTablaConfig);
        }
        setIndiceConfig(mcsNombreDefecto);
//        System.out.println("setDatos fin");
    }

//    public void finalizar(){
//        moTablaReal.removeComponentListener(this);
//        moTablaReal.removeFocusListener(this);
//
//    }
    public static synchronized void setConfigTablas(JTablaConfigTablas poConfig) {
        moConfigTablas = poConfig;
    }

    public static synchronized JTablaConfigTablas getConfigTablas() {
        if (moConfigTablas == null) {
            try {
                moConfigTablas = JTablaConfigLector.getTablaConfigTablas(JGUIxConfigGlobalModelo.getInstancia().getFicheroLongTablas());
            } catch (Exception ex) {
                JDepuracion.anadirTexto(JTablaConfigAbstract.class.getName(), ex.toString());
                moConfigTablas = new JTablaConfigTablas();
            }
        }
        return moConfigTablas;
    }

    public boolean[] getCamposVisibles() {
        if (mbInicializado) {
            boolean[] labVisibles = new boolean[moTablaConfigConcreta.size()];
            for (int i = 0; i < moTablaConfigConcreta.size(); i++) {
                labVisibles[i] = moTablaConfigConcreta.getColumna(i).getLong() > 0;
            }
            return labVisibles;
        }
        return new boolean[0];
    }

    public JTablaConfigTablaConfig getConfigTablaConcreta() {
        return moTablaConfigConcreta;
    }

    public JTablaConfigTabla getConfigTabla() {
        return moTablaConfig;
    }

    public String getIndiceConfig() {
        return moTablaConfigConcreta.getNombre();
    }

    public JTablaConfigColumna getTablaConfigColumnaDeCampoReal(final int i) {

        return moTablaConfigConcreta.getColumna(String.valueOf(i));
    }


    public abstract void setIndiceConfig(final String psNombre) ;

    public abstract void aplicar();

    public void borrar() throws Exception {
        if (moTablaConfigConcreta.getNombre().equals(mcsNombreDefecto)) {
            throw new Exception("No se puede borrar la config. por defecto");
        } else {
            moTablaConfig.removeConfig(moTablaConfigConcreta.getNombre());
            moTablaConfigConcreta = moTablaConfig.getConfig(0);
//            guardarConfig();
        }
    }

    public synchronized static void guardarConfig() throws FileNotFoundException, IOException {
        if (moConfigTablas != null) {
            JTablaConfigLector.guardar(getConfigTablas(), JGUIxConfigGlobalModelo.getInstancia().getFicheroLongTablas());
        }
    }

    public void setAnularEventos(boolean b) {
        mbAnularEventos = b;
    }

}


