/*
 * JPlugInManager.java
 *
 * Created on 7 de septiembre de 2006, 18:02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package utilesGUIx.plugin;

import utiles.IListaElementos;
import utiles.JDepuracion;
import utiles.JListaElementos;
import utilesGUIx.formsGenericos.IPanelControlador;

public class JPlugInManager implements IPlugInManager {
    protected IListaElementos moListaPlugIn = new JListaElementos();
    private IPlugInManager moSeguridad;
    
    /** Creates a new instance of JPlugInManager */
    public JPlugInManager(final String[] pasListaClases) {
        if(pasListaClases!=null){
            for(int i = 0; i < pasListaClases.length; i++){
                addPlugIn(pasListaClases[i]);
            }
        }
    }
    public void crearPlugInSeguridad(){
        moSeguridad = new JPlugInManager(null);
    }
    public void setPlugInSeguridad(IPlugInManager poSeguridad){
        moSeguridad = poSeguridad;
    }
    public IPlugInManager getPlugInSeguridad(){
        return moSeguridad;
    }
    public void addPlugIn(String psClase){
        try{
            IPlugIn loApli = (IPlugIn)this.getClass().forName(psClase).newInstance();
            moListaPlugIn.add(loApli);
        }catch(Throwable e){
            JDepuracion.anadirTexto(getClass().getName(), e.toString());
        }
        
    }
    public void addPlugIn(IPlugIn loApli){
        moListaPlugIn.add(loApli);
    }
    public void procesarConsulta(IPlugInContexto poContexto, IPlugInConsulta poConsulta){
        if(!poConsulta.getParametros().isPlugInPasados()){
            for(int i = 0; i < moListaPlugIn.size();i++ ){
                IPlugIn loPlugIn = (IPlugIn)moListaPlugIn.get(i);
                loPlugIn.procesarConsulta(poContexto, poConsulta);
            }
            if(moSeguridad!=null){
                moSeguridad.procesarConsulta(poContexto, poConsulta);
            }
            poConsulta.getParametros().setPlugInPasados(true);
        }
    }
    
    public void procesarInicial(IPlugInContexto poContexto) {
        for(int i = 0; i < moListaPlugIn.size();i++ ){
            IPlugIn loPlugIn = (IPlugIn)moListaPlugIn.get(i);
            try{
                loPlugIn.procesarInicial(poContexto);
            }catch(Throwable e){
                JDepuracion.anadirTexto(getClass().getName(), e);
            }
        }
        if(moSeguridad!=null){
            moSeguridad.procesarInicial(poContexto);
        }
    }

    public void procesarEdicion(IPlugInContexto poContexto, IPlugInFrame poFrame) {
        if(!poFrame.getParametros().isPlugInPasados()){
            for(int i = 0; i < moListaPlugIn.size();i++ ){
                IPlugIn loPlugIn = (IPlugIn)moListaPlugIn.get(i);
                loPlugIn.procesarEdicion(poContexto, poFrame);
            }
            if(moSeguridad!=null){
                moSeguridad.procesarEdicion(poContexto, poFrame);
            }
            poFrame.getParametros().setPlugInPasados(true);
        }
    }

    public void procesarControlador(IPlugInContexto poContexto, IPanelControlador poControlador) {
        if(!poControlador.getParametros().isPlugInPasados()){
            for(int i = 0; i < moListaPlugIn.size();i++ ){
                IPlugIn loPlugIn = (IPlugIn)moListaPlugIn.get(i);
                loPlugIn.procesarControlador(poContexto, poControlador);
            }
            if(moSeguridad!=null){
                moSeguridad.procesarControlador(poContexto, poControlador);
            }
            poControlador.getParametros().setPlugInPasados(true);
        }
    }
    
}
