/*
* JT2ACUERDOS.java
*
* Creado el 20/8/2012
*/
package impresionXML.impresion.word.combinar;

import ListDatos.*;
import java.awt.event.*;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import utilesGUIx.ActionEventCZ;
import utilesGUIx.formsGenericos.*;
import utilesGUIx.formsGenericos.boton.JBotonRelacionado;
import utilesGUIx.formsGenericos.busqueda.*;
import utilesGUIx.seleccionFicheros.JFileChooserFiltroPorExtension;

public class JT2WORD  extends JT2GENERALBASE2 {
    private static final String mcsImportar = "Importar";
    private static final String mcsRenombrar="Renombrar";
    private final JTFORMWORD moConsulta;
    private final IServerServidorDatos moServer;
    private String msDirActual="";
    private final JListDatos moFuente;
    private final JWord moWord;


    /** Crea una nueva instancia de JT2ACUERDOS */
    public JT2WORD(final IServerServidorDatos poServidorDatos, final IMostrarPantalla poMostrarPantalla, JListDatos poFuente, String psRutaTrabajo) throws Exception {
        super();
        moFuente=poFuente;
        moServer = poServidorDatos;
        moWord = new JWord(moFuente.msTabla, psRutaTrabajo);
        moConsulta = new JTFORMWORD(moWord);
        moConsulta.crearSelectSimple();
        addBotones();
        moParametros.setLongitudCampos(getLongitudCampos());
        moParametros.setNombre("WORD");
        getParametros().setMostrarPantalla(poMostrarPantalla);
        getParametros().setPlugInPasados(true);
        moWord.generarPlantilla(moFuente);
        

    }

    public IConsulta getConsulta() {
        return moConsulta;
    }

    public void mostrarFormPrinci() throws Exception {
        getParametros().getMostrarPantalla().mostrarFormPrinci(this, 800,600);
    }
    public void anadir() throws Exception {
        String lsNombre = JOptionPane.showInputDialog("Nombre plantilla");
        if(lsNombre!=null && !lsNombre.equals("")){
            if(lsNombre.indexOf(".doc")<0){
                lsNombre = lsNombre + ".doc";
            }
            if(moConsulta.moList.buscar(JListDatos.mclTIgual, 0, lsNombre)){
                throw new Exception("El nombre de la plantilla " + lsNombre + " ya existe");
            }

            moWord.crearPlantilla(lsNombre);
            JFilaDatosDefecto loFila = new JFilaDatosDefecto(new String[]{lsNombre});
            loFila.setTipoModif(JListDatos.mclNuevo);
            datosactualizados(loFila);
        }
    }

    public void valoresDefecto(final JSTabla poTabla) throws Exception {
    }

    public void borrar(final int plIndex) throws Exception {
        moConsulta.moList.setIndex(plIndex);
        String lsNombre = moConsulta.moList.getFields(0).getString();
        
        moWord.borrar(lsNombre);
        
        JFilaDatosDefecto loFila = new JFilaDatosDefecto(new String[]{lsNombre});
        loFila.setTipoModif (JListDatos.mclBorrar);
        datosactualizados(loFila);
    }

    public void editar(final int plIndex) throws Exception {
        moConsulta.moList.setIndex(plIndex);
        moWord.mostrarPlantilla(moConsulta.moList.getFields(0).getString());
    }

    public String getNombre() {
        return ("Word");
    }

    public int[] getLongitudCampos() {
        int[] loInt = new int[moConsulta.getFields().size()];

        loInt[moConsulta.lPosiNOMBRE]=200;
        return loInt;
    }

    public void actionPerformed(ActionEventCZ e, int[] plIndex) throws Exception {
        if(e.getActionCommand().equals(mcsImportar)){

            JFileChooserFiltroPorExtension filtro = new JFileChooserFiltroPorExtension(
                    "Documentos (.doc, .docx)"
                    , new String[]{"doc", "docx"}
                    );

            JFileChooser loFileM = new JFileChooser();
            loFileM.setFileFilter(filtro);

            if (!msDirActual.equals("")) {
                loFileM.setCurrentDirectory(new File(msDirActual));
            }
            if (loFileM.showOpenDialog(new JLabel()) == JFileChooser.APPROVE_OPTION) {
                File loFile = loFileM.getSelectedFile();
                msDirActual = loFile.getParent();
                if (!loFile.exists()) {
                    throw new Exception("Fichero no existe " + loFile.getName());

                } else {
                    String lsNombre = moWord.procesar(loFile.getAbsolutePath());
                    JFilaDatosDefecto loFila = new JFilaDatosDefecto(new String[]{lsNombre});
                    loFila.setTipoModif(JListDatos.mclNuevo);
                    datosactualizados(loFila);
                }
            }            
        }else{
            if(plIndex.length>0){
                for(int i = 0 ; i < plIndex.length; i++){
                    moConsulta.moList.setIndex(plIndex[i]);
                    if(e.getActionCommand().equals(mcsRenombrar)){
                        String lsAntig = moConsulta.moList.getFields(0).getString();
                        String lsExten = JWord.getExtesionFichero(lsAntig);
                        String lsNombre = JOptionPane.showInputDialog("Nuevo nombre para la plantilla " + lsAntig, JWord.getNombreFicheroSinExtension(lsAntig));
                        lsNombre=lsNombre+lsExten;
                        moWord.renombrar(lsAntig, lsNombre);
                        moConsulta.moList.setIndex(plIndex[i]);
                        moConsulta.moList.getFields(0).setValue(lsNombre);
                        moConsulta.moList.update(false);
                        getPanel().refrescar();
                        
            
                    }
                }
            }else{
                throw new Exception("No existe una fila actual");
            }
        }
            
    }


    public void addBotones() {
        JPanelGeneralBotones retValue;
        
        retValue = getParametros().getBotonesGenerales();
        retValue.addBotonPrincipal(new JBotonRelacionado(mcsImportar, mcsImportar, "/images/Import24.gif", this));
        retValue.addBotonPrincipal(new JBotonRelacionado(mcsRenombrar, mcsRenombrar, "/images/BePaint.gif", this));
         
    }


}