/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package impresionXML.impresion.word.combinar;

import ListDatos.JListDatos;
import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import utiles.CadenaLarga;
import utiles.CadenaLargaOut;
import utiles.JArchivo;
import utilesx.JEjecutar;

/**
 *
 * @author eduardo
 */
public class JWord {

    public static final String mcsPlantillaDir = "plantilla";
    public static final String mcsPlantilla = "plantilla.txt";
    public static final String mcsWORD = "word";
    private final String msGrupo;
    private final String msDirecTrabajo;

    public JWord(String psGrupo, String psDirecTrabajo) {
        msGrupo = psGrupo;
        msDirecTrabajo = psDirecTrabajo;
        File loFile = new File(msDirecTrabajo);
        loFile.mkdirs();
    }

    public static String getIdentWord(final String psTabla, final String psCampo) {
        String lsResult = "";
        if (psCampo == null || psCampo.equals("")) {
            lsResult = psTabla.trim();
        } else {
            if (psTabla == null || psTabla.equals("")) {
                lsResult = psCampo.trim();
            } else {
                lsResult = psTabla.trim() + "_" + psCampo.trim();
            }
        }
        if (lsResult.length() > 41) {
            lsResult = lsResult.substring(0, 40);
        }
        return lsResult;
    }

    public File getRutaBase() throws Exception {
        File loFile = new File(msDirecTrabajo, mcsWORD);
        loFile.mkdirs();
        loFile = new File(loFile, msGrupo);
        loFile.mkdirs();
        return loFile;
    }

    public File getPlantilla() throws Exception {
        File loFile = getRutaBase();
        loFile = new File(loFile, mcsPlantillaDir);
        loFile.mkdirs();
        loFile = new File(loFile, mcsPlantilla);
        return loFile;
    }

    public void generarPlantilla(JListDatos poList) throws Exception {
        generarPlantilla(poList, getPlantilla().getAbsolutePath());
    }

    public static void generarPlantilla(JListDatos poList, String psFile) throws Exception {
        FileOutputStream loOut = new FileOutputStream(psFile);
        PrintWriter loPrint = new PrintWriter(loOut);
        try {
            for (int i = 0; i < poList.getFields().size(); i++) {
                loPrint.write(getIdentWord(poList.getFields(i).getTabla(), poList.getFields(i).getNombre()) + '\t');
            }
            loPrint.write('\n');
            if (poList.moveFirst()) {
                do {
                    for (int i = 0; i < poList.getFields().size(); i++) {
                        loPrint.write(poList.getFields(i).getString() + '\t');
                    }
                    if (poList.mlIndex != poList.size() - 1) {//la ultima fila sin intro
                        loPrint.write('\n');
                    }
                } while (poList.moveNext());
            }
        } finally {
            loPrint.close();
            loOut.close();
        }
    }

    public void rellenarListaWord(JListDatos loResult) throws Exception {
        loResult.clear();
        File loDir = getRutaBase();
        File[] loFiles = loDir.listFiles();
        for (int i = 0; i < loFiles.length; i++) {
            if (!loFiles[i].isDirectory() && loFiles[i].getName().indexOf("doc") >= 0) {
                loResult.addNew();
                loResult.getFields(0).setValue(loFiles[i].getName());
                loResult.update(false);
            }
        }
    }

    public JListDatos getListaWord() throws Exception {
        JListDatos loResult = new JListDatos(null, "WORD", new String[]{"Nombre"}, new int[]{JListDatos.mclTipoCadena}, new int[]{0});
        rellenarListaWord(loResult);
        return loResult;
    }

    public static final String getExtesionFichero(String psNombre) {
        String lsResult;
        int lPunto = psNombre.lastIndexOf('.');
        if (lPunto > 0) {
            lsResult = psNombre.substring(lPunto);
        } else {
            lsResult = "";
        }
        return lsResult;
    }

    public static final String getNombreFicheroSinExtension(String psNombre) {
        String lsResult;
        int lPunto = psNombre.lastIndexOf('.');
        if (lPunto > 0) {
            lsResult = psNombre.substring(0, lPunto);
        } else {
            lsResult = psNombre;
        }
        return lsResult;
    }

    public void borrar(String lsNombre) throws Exception {
        File loFile = new File(getRutaBase(), lsNombre);
        if (loFile.exists()) {
            if (!loFile.delete()) {
                throw new Exception("No se ha podido borrar la plantilla " + lsNombre);
            }
        }
    }

    public void renombrar(String lsAntig, String lsNombre) throws Exception {
        File loFile = new File(getRutaBase(), lsAntig);
        if (loFile.exists()) {
            File loFileAux = new File(getRutaBase(), lsNombre);
            if (!loFile.renameTo(loFileAux)) {
                throw new Exception("No se ha podido renombrar la plantilla " + lsAntig + " a " + lsNombre);
            }
        }
    }

    public String procesar(String psWord) throws Exception {
        File loFile = new File(psWord);
        String lsNombre = loFile.getName();
        if (loFile.exists()) {
            //entonces es un externo, pq si no existe es que es ruta relativa
            File loAux = new File(getRutaBase(), loFile.getName());
            //comprobamos q no existe en el direc. word, si existe le cambiamos nombre
            int i = 0;
            while (loAux.exists()) {
                i++;
                int lPunto = loFile.getName().lastIndexOf('.');
                if (lPunto > 0) {
                    loAux = new File(getRutaBase(), loFile.getName().substring(0, lPunto) + String.valueOf(i) + loFile.getName().substring(lPunto));
                } else {
                    loAux = new File(getRutaBase(), String.valueOf(i) + loFile.getName());
                }

            }
            //guardamos en el direc. de word
            JArchivo.guardarArchivo(loFile, loAux);
            lsNombre = loAux.getName();
        } else {
            lsNombre = psWord;
        }

        loFile = new File(getRutaBase(), lsNombre);
        if (loFile.exists()) {
            File loVBS = new File(getRutaBase(), "enlace.vbs");
            JArchivo.guardarArchivo(
                    new CadenaLarga(getVBScripEnlace(loFile, getPlantilla())), new FileOutputStream(loVBS));
            ejecutarVBS(loVBS.getAbsolutePath());
        } else {
            throw new Exception("Fichero no existe " + lsNombre);
        }

        return lsNombre;
    }

    public String crearPlantilla(String lsNombre) throws Exception {
        File loFile = new File(getRutaBase(), lsNombre);
        if (!loFile.exists()) {
            File loVBS = new File(getRutaBase(), "nueva.vbs");
            JArchivo.guardarArchivo(
                    new CadenaLarga(getVBScripEnlaceNueva(loFile, getPlantilla())), new FileOutputStream(loVBS));
            ejecutarVBS(loVBS.getAbsolutePath());
        } else {
            throw new Exception("Fichero no existe " + lsNombre);
        }
        return lsNombre;
    }

    public void mostrarPlantilla(String lsNombre) throws Exception {
        File loFile = new File(getRutaBase(), lsNombre);
        if (loFile.exists()) {
            File loVBS = new File(getRutaBase(), "enlace.vbs");
            JArchivo.guardarArchivo(
                    new CadenaLarga(getVBScripEnlace(loFile, getPlantilla())), new FileOutputStream(loVBS));
            ejecutarVBS(loVBS.getAbsolutePath());
        } else {
            throw new Exception("Fichero no existe " + lsNombre);
        }
    }

    public void combinarPlantilla(String lsNombre, JListDatos poList) throws Exception {
        File loFile = new File(getRutaBase(), lsNombre);
        if (loFile.exists()) {
            generarPlantilla(poList);
            File loVBS = new File(getRutaBase(), "combinar.vbs");
            JArchivo.guardarArchivo(
                    new CadenaLarga(getVBScripCombinarPlantilla(loFile, getPlantilla())), new FileOutputStream(loVBS));
            ejecutarVBS(loVBS.getAbsolutePath());
        } else {
            throw new Exception("Fichero no existe " + lsNombre);
        }
    }


    public void ejecutarVBS(String psVBS) throws Exception {
        JEjecutar loEje = new JEjecutar(new String[]{"cscript", psVBS}, getRutaBase());
        CadenaLargaOut loOut = new CadenaLargaOut();
        CadenaLargaOut loError = new CadenaLargaOut();
        loEje.setOutputProceso(loOut);
        loEje.setOuterrorProceso(loError);
        loEje.run();
        if (loEje.getExitVal() != 0) {
            throw new Exception(loOut.moStringBuffer.toString() + "\n" + loError.moStringBuffer.toString());
        }
    }

    public String getVBScripCombinareMail(File poDoc, File poTXT, File poTMP) {
        StringBuffer lsVB = new StringBuffer(500);

        lsVB.append("Set objWord = CreateObject(\"Word.Application\")");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Documents.Open \"" + poDoc.getAbsolutePath() + "\", False,False, False, \"\", \"\", False, \"\", \"\", 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.MailMerge.OpenDataSource  \"" + poTXT.getAbsolutePath() + "\", 0, False, False, True,  False, \"\", \"\", False, \"\", \"\",  \"\", \"\", \"\", False, 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("With objWord.ActiveDocument.MailMerge");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".Destination = 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".SuppressBlankLines = True");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("With .DataSource");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".FirstRecord = 1");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".LastRecord = -16");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("End With");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".Execute False");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("End With");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.SaveAs \"" + poTMP.getAbsolutePath() + "\"");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Application.Quit False ");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));

        return lsVB.toString();
    }
    private String getVBScripCombinarPlantilla(File poDoc, File poTXT) {
        StringBuffer lsVB = new StringBuffer(500);

        lsVB.append("Set objWord = CreateObject(\"Word.Application\")");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Visible = True");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Documents.Open \"" + poDoc.getAbsolutePath() + "\", False,False, False, \"\", \"\", False, \"\", \"\", 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.MailMerge.OpenDataSource  \"" + poTXT.getAbsolutePath() + "\", 0, False, False, True,  False, \"\", \"\", False, \"\", \"\",  \"\", \"\", \"\", False, 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("With objWord.ActiveDocument.MailMerge");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".Destination = 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".SuppressBlankLines = True");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("With .DataSource");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".FirstRecord = 1");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".LastRecord = -16");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("End With");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append(".Execute False");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("End With");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Windows(\"" + poDoc.getName() + "\").Activate");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.Save");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveWindow.Close");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));

        return lsVB.toString();
    }

    private String getVBScripEnlace(File poDoc, File poTXT) {
        StringBuffer lsVB = new StringBuffer(500);

        lsVB.append("Set objWord = CreateObject(\"Word.Application\")");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Visible = True");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Documents.Open \"" + poDoc.getAbsolutePath() + "\", False,False, False, \"\", \"\", False, \"\", \"\", 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.MailMerge.OpenDataSource  \"" + poTXT.getAbsolutePath() + "\", 0, False, False, True,  False, \"\", \"\", False, \"\", \"\",  \"\", \"\", \"\", False, 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Windows(\"" + poDoc.getName() + "\").Activate");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.Save");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        return lsVB.toString();
    }

    private String getVBScripEnlaceNueva(File poDoc, File poTXT) {
        StringBuffer lsVB = new StringBuffer(500);

        lsVB.append("Set objWord = CreateObject(\"Word.Application\")");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Visible = True");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.Documents.Add()");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.MailMerge.OpenDataSource  \"" + poTXT.getAbsolutePath() + "\", 0, False, False, True,  False, \"\", \"\", False, \"\", \"\",  \"\", \"\", \"\", False, 0");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        lsVB.append("objWord.ActiveDocument.SaveAs \"" + poDoc.getAbsolutePath() + "\"");
        lsVB.append(((char) 13)); lsVB.append(((char) 10));
        return lsVB.toString();
    }
}
