/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package paquetesGeneradorInf.gui.resultados.exportar;

import ListDatos.JListDatos;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

/**
 *
 * @author eduardo
 */
public class JExportarExcel  implements IExportar {

    public JExportarExcel() {

    }

    public void exportar(JListDatos poList, File poFile) throws Throwable {
        HSSFWorkbook workbook = new HSSFWorkbook();
        HSSFSheet sheet=workbook.createSheet("Nueva Hoja");

        HSSFCellStyle style = workbook.createCellStyle();
//        style.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
        style.setWrapText(true);
        HSSFFont font = workbook.createFont();
        font.setFontHeightInPoints((short)10);
        font.setFontName("Courier New");
        font.setItalic(true);
        // font.setStrikeout(true);
        font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
        //font.setColor(Short.parseShort("#ffffff"));
        style.setFont(font);

        int lFila = 0;
        HSSFRow row = sheet.createRow((short) lFila);
        createCell(row, 0, poList.msTabla);
        
        lFila++;
        crearCabecera(poList, sheet, style, lFila);

        if (poList.moveFirst()) {
            do {
                lFila++;
                toExcel(poList, workbook, lFila, sheet);
            } while (poList.moveNext());

        }

        // Escribir el fichero.
        OutputStream fileOut = new FileOutputStream(poFile);
        try{
            workbook.write(fileOut);
        }finally{
            fileOut.close(); 
        }
        utilesx.JEjecutar.abrirDocumento(poFile.getAbsolutePath()); 

    }

    public String getNombre() {
        return "Formato Excel";
    }

    public String[] getOpcionesNombre() {
        return null;
    }
    public String[] getOpciones() {
        return null;

    }

    public void setOpciones(String[] pasOpciones) {

    }
    public String[] getExtensiones() {
       return new String[]{"xls","xlsx"};
    }

    public static void createCell(HSSFRow row, int i, String value) {
        createCell(row, i, value, null);
    }
    public static void createCell(HSSFRow row, int i, double value) {
        HSSFCell cell = row.createCell((short)i);
        cell.setCellValue(value);
    }
    public static void createCell(HSSFRow row, int i, String value, HSSFCellStyle style) {
        HSSFCell cell = row.createCell((short)i);
        value = value+" ";
        cell.setCellValue(value);
        // si no hay estilo, no se aplica
        if (style != null)
        cell.setCellStyle(style);
    }

    public void crearCabecera(JListDatos poList, HSSFSheet sheet, HSSFCellStyle cfobj, int plfila) throws Exception {
        HSSFRow row = sheet.createRow((short) plfila);
        for(int i = 0 ; i < poList.getFields().size(); i++){
            createCell(row,i,poList.getFields(i).getCaption(), cfobj);
        }
    }

    public void toExcel(JListDatos poList, HSSFWorkbook workbook, int plfila, HSSFSheet sheet) throws Exception {
        HSSFRow row = sheet.createRow((short) plfila);
        for(int i = 0 ; i < poList.getFields().size(); i++){
            if(poList.getFields(i).getTipo()==JListDatos.mclTipoNumero 
                    || poList.getFields(i).getTipo()==JListDatos.mclTipoNumeroDoble 
                    || poList.getFields(i).getTipo()==JListDatos.mclTipoMoneda3Decimales 
                    || poList.getFields(i).getTipo()==JListDatos.mclTipoMoneda 
                    || poList.getFields(i).getTipo()==JListDatos.mclTipoPorcentual3Decimales 
                    || poList.getFields(i).getTipo()==JListDatos.mclTipoPorcentual ){
                createCell(row,i,poList.getFields(i).getDouble());
            }else{
                createCell(row,i,poList.getFields(i).getString());
            }
        }
    }   
}
