/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utilesBD.estructuraBD;

import ListDatos.JListDatos;
import ListDatos.estructuraBD.IConstructorEstructuraBD;
import ListDatos.estructuraBD.JFieldDef;
import ListDatos.estructuraBD.JIndiceDef;
import ListDatos.estructuraBD.JRelacionesDef;
import ListDatos.estructuraBD.JTableDef;
import ListDatos.estructuraBD.JTableDefs;
import com.healthmarketscience.jackcess.Column;
import com.healthmarketscience.jackcess.DataType;
import com.healthmarketscience.jackcess.Database;
import com.healthmarketscience.jackcess.Index;
import com.healthmarketscience.jackcess.IndexData;
import com.healthmarketscience.jackcess.PropertyMap;
import com.healthmarketscience.jackcess.Table;
import java.io.File;
import java.util.Iterator;
import java.util.List;
import utiles.JDepuracion;

/**
 *
 * @author eduardo
 */
public class JConstructorEstructuraBDACCESS  implements IConstructorEstructuraBD {

    private Database moBD;
    private String msRuta;
    private JTableDefs moEstructura=null;
    private boolean mbconRelacionesExport;
    private boolean mbconRelacionesInport;
    private boolean mbRelacionesOptimizar=true;

    /** Creates a new instance of JConstructorMetaDatosBD */
    public JConstructorEstructuraBDACCESS(String psRuta) {
        setRuta(psRuta);
        mbconRelacionesExport = true;
        mbconRelacionesInport = true;
    }
    public JConstructorEstructuraBDACCESS(String psRuta, boolean pbOptimizado) {
        this(psRuta);
        mbRelacionesOptimizar = pbOptimizado;
    }
    public JConstructorEstructuraBDACCESS(String psRuta, boolean pbconRelacionesExport, boolean pbconRelacionesInport) {
        this(psRuta);
        mbconRelacionesExport = pbconRelacionesExport;
        mbconRelacionesInport = pbconRelacionesInport;
    }
    public synchronized void setRelacionesOptimizar(boolean pbOptimizar){
        mbRelacionesOptimizar = pbOptimizar;
    }
    public synchronized  void setRuta(String psBD) {
        msRuta=psBD;
        
    }
    public synchronized String getRuta(){
        return msRuta;
    }
    //recuperamos la estructura de la base de datos
    public synchronized JTableDefs getTableDefs() throws Exception {
        if(moEstructura==null){
            moBD = Database.open(new File(msRuta));
            moEstructura = new JTableDefs();
            String lsTipo;
            int lnTipo = JTableDef.mclTipoTabla;

            try {
                //Recuperar Tablas
                Iterator loIter = moBD.getTableNames().iterator();
                while(loIter.hasNext()) {
                    String lsTabla = loIter.next().toString();
                    lnTipo = JTableDef.mclTipoTabla;
                    JTableDef loTabla = new JTableDef(lsTabla, lnTipo);
                    Table loTable = moBD.getTable(lsTabla);
                    recuperarIndices(loTabla, loTable); //Recuperamos los indices de la tabla
                    recuperarCampos(loTabla, loTable); //Recuperamos todos los campos
                    moEstructura.add(loTabla);  //Anadimos la tabla a la estructura
                }
//                if(mbconRelacionesExport){
//                    recuperarRelaciones(moEstructura,JRelacionesDef.mclRelacionExport); //Recuperamos las claves exportadas
//                }
//                //si es optimizar las relaciones import se calculan a partir de las export
//                //se supone q una relacion import es la inversa de una relacion export
//                if(mbconRelacionesInport && !mbRelacionesOptimizar){
//                    recuperarRelaciones(moEstructura,JRelacionesDef.mclRelacionImport); //Recuperamos las claves importadas
//                }
            }catch(Exception e) {
                JDepuracion.anadirTexto(JDepuracion.mclWARNING, getClass().getName(), e);
            } finally{
                moBD=null;
            }
        }
        return moEstructura;
    }


    //Recuperamos los campos de la tabla
    private void recuperarCampos(final JTableDef poTabla, Table loTable) throws Exception {
        String lsCampo;

        try {
            try{
                for(int i = 0 ; i < loTable.getColumnCount(); i++) {
                    Column loColumna = (Column) loTable.getColumns().get(i);
                    String lsTableName = poTabla.getNombre();
                    DataType loTipo = loColumna.getType();
                    int lnTipo = JListDatos.mclTipoCadena;
                    if(loTipo == DataType.BOOLEAN ){
                        lnTipo = JListDatos.mclTipoBoolean;
                    }
                    if(loTipo == DataType.BINARY 
                            || loTipo == DataType.MEMO 
                            || loTipo == DataType.TEXT
                            ){
                        lnTipo = JListDatos.mclTipoCadena;
                    }
                    if(loTipo == DataType.DOUBLE 
                            || loTipo == DataType.FLOAT
                            || loTipo == DataType.MONEY
                            || loTipo == DataType.NUMERIC
                            ){
                        lnTipo = JListDatos.mclTipoNumeroDoble;
                    }
                    if(loTipo == DataType.BYTE 
                            || loTipo == DataType.INT
                            || loTipo == DataType.LONG
                            ){
                        lnTipo = JListDatos.mclTipoNumero;
                    }
                    if(loTipo == DataType.SHORT_DATE_TIME 
                            ){
                        lnTipo = JListDatos.mclTipoFecha;
                    }
                    boolean lbNullable = true;
                    String lsDescrip="";
                    Iterator loItP = loColumna.getProperties().iterator();
                    while(loItP.hasNext()){
                        PropertyMap.Property lsNombre = (PropertyMap.Property) loItP.next();
                        if(lsNombre.getName().equalsIgnoreCase("Required")){
                            lbNullable = !((Boolean)lsNombre.getValue()).booleanValue();
                        }
                        
                   }


                    lsCampo = loColumna.getName();
                    int lSize = loColumna.getLength();

                    JFieldDef loCampo = new JFieldDef(
                            lnTipo
                            ,lsCampo,""
                            ,esPrimaryKey(poTabla,lsCampo)
                            ,lSize
                            ,loTipo.name()
                            ,lbNullable 
                            ,lsDescrip);
                    poTabla.getCampos().addField(loCampo);
                }

            }finally{
            }
        }catch(Exception e) {
            JDepuracion.anadirTexto(JDepuracion.mclINFORMACION, getClass().getName(), e);
            throw e;
        }
    }

    private boolean esPrimaryKey(JTableDef poTabla,String psNombre) throws Exception {
        boolean lbResult =false;
        try {
            String lsNombre = psNombre.toUpperCase();
            for(int i = 0 ; i < poTabla.getIndices().getListaIndices().size(); i++){
                JIndiceDef loIndice = poTabla.getIndices().getIndice(i);
                if(loIndice.getEsPrimario()){
                    for(int ii = 0; ii < loIndice.getListaCampos().size();ii++){
                        if(loIndice.getCampoIndice(ii).toUpperCase().compareTo(lsNombre)==0){
                            lbResult = true;
                            break;
                        }
                    }
                }
            }
        }catch(Exception e) {
            JDepuracion.anadirTexto(JDepuracion.mclINFORMACION, getClass().getName(), e);
            throw e;
        }
        return lbResult;
    }

    private void crearRelacionInversa(JTableDef poTabla, JRelacionesDef poRelacion) throws Exception {
        JRelacionesDef loRelacionInv = new JRelacionesDef(poRelacion.getNombreRelacion() + "inversa");
        JTableDef loTablaInv = moEstructura.get(poRelacion.getTablaRelacionada());
        loTablaInv.getRelaciones().addRelacion(loRelacionInv);
        switch(poRelacion.getTipoRelacion()){
            case JRelacionesDef.mclRelacionImport:
                loRelacionInv.setTipoRelacion(JRelacionesDef.mclRelacionExport);
                break;
            case JRelacionesDef.mclRelacionExport:
                loRelacionInv.setTipoRelacion(JRelacionesDef.mclRelacionImport);
                break;
            default:
                throw new Exception("(RecuperarRelaciones)Opcion de la relacion incorrecta");
        }
        loRelacionInv.setTablaRelacionada(poTabla.getNombre());
        loRelacionInv.setDelete(poRelacion.getDelete());
        loRelacionInv.setUpdate(poRelacion.getUpdate());
        for(int i = 0 ; i < poRelacion.getCamposRelacionCount(); i++){
            loRelacionInv.addCampoRelacion(
                    poRelacion.getCampoRelacion(i),
                    poRelacion.getCampoPropio(i)
                    );
        }


    }
    private void recuperarRelaciones(JTableDef poTabla, Index poIndex) throws Exception {

        try {
            JRelacionesDef loRelacion = new JRelacionesDef(poTabla.getNombre() + "_" + poIndex.getName());
            loRelacion.setTabla(poTabla.getNombre());
            loRelacion.setTablaRelacionada(poIndex.getReferencedIndex().getTable().getName());
            loRelacion.setDelete(poIndex.getReference().isCascadeDeletes() ? loRelacion.mclimportedKeyCascade : loRelacion.mclimportedKeySetDefault);
            loRelacion.setUpdate(poIndex.getReference().isCascadeUpdates()? loRelacion.mclimportedKeyCascade : loRelacion.mclimportedKeySetDefault);

            Index loIndexForaneo = poIndex.getReferencedIndex();
            for(int lCol = 0 ; lCol < poIndex.getColumns().size();lCol++){
                IndexData.ColumnDescriptor loColum = (IndexData.ColumnDescriptor) poIndex.getColumns().get(lCol);
                IndexData.ColumnDescriptor loColumFora = (IndexData.ColumnDescriptor) loIndexForaneo.getColumns().get(lCol);
                
                loRelacion.addCampoRelacion(loColum.getName(), loColumFora.getName());
            }
            poTabla.getRelaciones().addRelacion(loRelacion);
            
            
            
        }catch(Exception e) {
            JDepuracion.anadirTexto(JDepuracion.mclINFORMACION, getClass().getName(), e);
            throw e;
        }
    }

    private void recuperarIndices(JTableDef poTabla, Table loTable) throws Exception {
        try {
            List loIndices = loTable.getIndexes();
            try{
                
                for(int i = 0 ; i < loIndices.size(); i++){
                    Index loIndex = (Index) loIndices.get(i);
                    
                    if(loIndex.isForeignKey()){
                        recuperarRelaciones(poTabla, loIndex);
                    }else{
                        JIndiceDef loIndice = new JIndiceDef(poTabla.getNombre() + "_" + loIndex.getName());
                        loIndice.setEsPrimario(loIndex.isPrimaryKey());
                        loIndice.setEsUnico(loIndex.isUnique());

                        for(int lCol = 0 ; lCol < loIndex.getColumns().size();lCol++){
                            IndexData.ColumnDescriptor loColum = (IndexData.ColumnDescriptor) loIndex.getColumns().get(lCol);
                            loIndice.addCampoIndice(loColum.getName());
                        }
                        poTabla.getIndices().addIndice(loIndice);
                    }
                }
            }finally{
            }
        }catch(Exception e) {
            JDepuracion.anadirTexto(JDepuracion.mclINFORMACION, getClass().getName(), e);
            throw e;
        }
    }
    
    public static void main(String[] pas){
        try {
            JConstructorEstructuraBDACCESS loAc = new JConstructorEstructuraBDACCESS("/home/eduardo/d/bda/intecsa/chs/Ipasub97.mdb");
            loAc.getTableDefs();
        } catch (Throwable ex) {
            ex.printStackTrace();
        }
    }
}
