package utilesGUI.grafxy;

/**
 * <p>Title: BDAInternet</p>
 * <p>Description: Aplicacin consulta BDA para la diputacin de Alicante</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Intecsa-inarsa</p>
 * @author Eduardo Gonzalez Carpena
 * @version 1.0
 */

import java.awt.Color;
import java.awt.Graphics;

/**Estilo linea*/
public class JEstiloLinea {
  /**
   * Color de la linea
   */
  public Color moColor=Color.blue;

  /**
   * Grosor de la linea
   */
  public int mlGrosor=1;

  /**
   * Construtor
   */
  public JEstiloLinea(){
  }

  /**
   * Construtor pasando el color y grosor por defecto
   * @param poColor Color
   * @param plGrosor grosor
   */
  public JEstiloLinea(Color poColor,int plGrosor) {
    moColor = poColor;
    mlGrosor = plGrosor;
  }
  /**
   * Establece el estilo al objeto grfico
   * @param g Objeto grfico
   */
  void setEstilo(Graphics g){
    g.setColor(moColor);
  }
  /**
   * Pinta en el objeto grfico la linea
   * @param g Objeto grfico
   * @param x x punto 1
   * @param y y punto 1
   * @param x2 x punto 2
   * @param y2 y punto 2
   */
  void pintar(Graphics g,int x,int y,int x2,int y2){
    setEstilo(g);
    for(int i = 0; i<mlGrosor;i++){
      g.drawLine(x,y+i,x2,y2+i);
    }
  }

}