/*
 * JDialogo.java
 *
 * Created on 29 de septiembre de 2003, 9:42
 */

package utilesGUI.msgbox;

/**Utilidad para mostrar un dialogo*/
public class JDialogo extends java.awt.Dialog implements java.awt.event.ActionListener {
    /**Dilogo con S/No*/
    public static final int mclSiNo = 0;
    /**Dilogo con S/No/Cancelar*/
    public static final int mclSiNoCancelar = 1;
    /**Dilogo con S/Cancelar*/
    public static final int mclSiCancelar = 2;
    /**Dilogo/resultado con OK*/
    public static final int mclOK = 3;
    /**Dilogo/resultado con S*/
    public static final int mclSi = 4;
    /**Dilogo con OK/Cancelar*/
    public static final int mclOKCancelar = 5;
    /**Dilogo/resultado con Cancelar*/
    public static final int mclCancelar = 6;
    /**Dilogo/resultado con No*/
    public static final int mclNo = 7;
    
    private static final String mcsSI = "S";
    private static final String mcsNO = "No";
    private static final String mcsCANCELAR = "Cancelar";
    private static final String mcsOK = "OK";
    
    /**Devuelve el ltimo botn pulsado del dilogo*/
    public static int mlUltValor=-1;
    /**Devuelve el ltimo valor puesto del dilogo*/
    public static String msUltValor="";
    
    public static int mlWidth = 350;
    public static int mlHeight = 300;
    
    
    /**
     * Creates new form JDialogo
     * @param parent frame padre
     * @param modal si es modal
     */
    public JDialogo(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setSize(mlWidth, mlHeight);
        setBounds(getLocation().x,getLocation().y, mlWidth, mlHeight);
        buttonEdu1.addActionListener(this);
        buttonEdu2.addActionListener(this);
        buttonEdu3.addActionListener(this);
    }
    /**
     * Pone los botones del dilogo en funcin de las constantes
     * @param plBotones cte botn
     */
    public void ponerBotones(int plBotones){
        switch(plBotones){
            case mclSiNo:
                buttonEdu1.setLabel(mcsSI);
                buttonEdu2.setLabel(mcsNO);
                buttonEdu3.setVisible(false);
                break;
            case mclSiNoCancelar:
                buttonEdu1.setLabel(mcsSI);
                buttonEdu2.setLabel(mcsNO);
                buttonEdu3.setLabel(mcsCANCELAR);
                break;
            case mclSiCancelar:
                buttonEdu1.setLabel(mcsSI);
                buttonEdu2.setVisible(false);
                buttonEdu3.setLabel(mcsCANCELAR);
                break;
            case mclOK:
                buttonEdu1.setLabel(mcsOK);
                buttonEdu2.setVisible(false);
                buttonEdu3.setVisible(false);
                break;
            case mclSi:
                buttonEdu1.setLabel(mcsSI);
                buttonEdu2.setVisible(false);
                buttonEdu3.setVisible(false);
                break;
            case mclOKCancelar:
                buttonEdu1.setLabel(mcsOK);
                buttonEdu2.setVisible(false);
                buttonEdu3.setLabel(mcsCANCELAR);
                break;
            case mclCancelar:
                buttonEdu1.setVisible(false);
                buttonEdu2.setVisible(false);
                buttonEdu3.setLabel(mcsCANCELAR);
                break;
            case mclNo:
                buttonEdu1.setVisible(false);
                buttonEdu2.setLabel(mcsNO);
                buttonEdu3.setVisible(false);
                break;
            default:
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panel1 = new java.awt.Panel();
        textFieldCZ1 = new utilesGUI.TextFieldCZ();
        panel2 = new java.awt.Panel();
        buttonEdu1 = new utilesGUI.ButtonCZ();
        buttonEdu2 = new utilesGUI.ButtonCZ();
        buttonEdu3 = new utilesGUI.ButtonCZ();
        textArea1 = new java.awt.TextArea();

        setBackground(java.awt.Color.white);
        setModal(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        panel1.setLayout(new java.awt.GridLayout(2, 0));

        panel1.add(textFieldCZ1);

        panel2.add(buttonEdu1);

        panel2.add(buttonEdu2);

        panel2.add(buttonEdu3);

        panel1.add(panel2);

        add(panel1, java.awt.BorderLayout.SOUTH);

        textArea1.setBackground(new java.awt.Color(255, 255, 255));
        textArea1.setEditable(false);
        textArea1.setRows(20);
        add(textArea1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void buttonEdu3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEdu3ActionPerformed
        // Add your handling code here:
        mlUltValor=mclCancelar;
        msUltValor = "";
        closeDialog(null);
        
    }//GEN-LAST:event_buttonEdu3ActionPerformed

    private void buttonEdu2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEdu2ActionPerformed
        // Add your handling code here:
        mlUltValor=mclNo;
        msUltValor = "";
        closeDialog(null);
        
    }//GEN-LAST:event_buttonEdu2ActionPerformed

    private void buttonEdu1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEdu1ActionPerformed
        // Add your handling code here:
        mlUltValor=mclSi;
        msUltValor = textFieldCZ1.getText();
        closeDialog(null);

    }//GEN-LAST:event_buttonEdu1ActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        if (evt != null){
            mlUltValor = mclCancelar;
            msUltValor = "";
        }
        setVisible(false);
        dispose();
        
    }//GEN-LAST:event_closeDialog
    

    /**
     * Muestra un dilogo para devolver texto
     * @param parent padre
     * @param psMensaje mensaje
     * @return texto
     */
    public static String showInputBox(Object parent, String psMensaje) {
        JDialogo loDialo =new JDialogo(new java.awt.Frame(), true);
        loDialo.setMensaje(psMensaje);
        loDialo.ponerBotones(mclSiNo);
        loDialo.textFieldCZ1.setVisible(true);
        loDialo.show();
        return msUltValor;
    }

    /**
     * Muestra un dilogo con ok
     * @param parent padre
     * @param psMensaje mensaje
     * @return resultado
     */
    public static int showDialog(Object parent, String psMensaje) {
        return showDialog(parent, psMensaje, mclOK);
        
    }

    /**
     * Muestra un dilogo con botones segun constante
     * @return resultado
     * @param plBotones CTE botones
     * @param parent padre padre
     * @param psMensaje mensaje
     */
    public static int showDialog(Object parent, String psMensaje, int plBotones) {
        JDialogo loDialo =new JDialogo(new java.awt.Frame(), true);
        loDialo.textFieldCZ1.setVisible(false);
        loDialo.setMensaje(psMensaje);
        loDialo.ponerBotones(plBotones);
        loDialo.show();
        return mlUltValor;
    }
    /**
     * Establece el mensaje
     * @param psMensaje mensaje
     */
    public void setMensaje(String psMensaje){
        if(psMensaje!=null){
            int lMax = psMensaje.length();
            int lCount = (psMensaje.length()/40)+1;
            int lFin = 0;
            for(int i = 0;i<lCount;i++){
                lFin = (i+1)*40;
            if (lFin>lMax) {
                    lFin = lMax;
                }
                textArea1.append(psMensaje.substring(i*40,lFin)+String.valueOf('\n'));
            }
        }
    }
    /**Evento al pulsar un botn*/
    public void actionPerformed(java.awt.event.ActionEvent e) {
        Object source = e.getSource();
        if(source == buttonEdu1){
            buttonEdu1ActionPerformed(e);
        }
        if(source == buttonEdu2) {
            buttonEdu2ActionPerformed(e);
        }
        if(source == buttonEdu3) {
            buttonEdu3ActionPerformed(e);
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private utilesGUI.ButtonCZ buttonEdu1;
    private utilesGUI.ButtonCZ buttonEdu2;
    private utilesGUI.ButtonCZ buttonEdu3;
    private java.awt.Panel panel1;
    private java.awt.Panel panel2;
    private java.awt.TextArea textArea1;
    private utilesGUI.TextFieldCZ textFieldCZ1;
    // End of variables declaration//GEN-END:variables

}
