/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utilesGUIx.cargaMasiva;

import ListDatos.IResultado;
import ListDatos.JFilaDatosDefecto;
import ListDatos.JListDatos;
import ListDatos.JSTabla;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import utilesGUIx.JGUIxConfigGlobal;
import utilesGUIx.controlProcesos.JProcesoAccionAbstracX;
import utilesGUIx.formsGenericos.JMostrarPantalla;
import utilesGUIx.formsGenericos.JPanelGenerico;
import utilesGUIx.formsGenericos.busqueda.JBusqueda;
import utilesGUIx.panelesGenericos.JConsulta;


public class JCargaMasiva extends JProcesoAccionAbstracX {
    private final JListDatos moList;
    private final String msCarga;
    private int mlRegistros=-1;
    private String[] masDatos=null;
    private final JListDatos moErrores;
    private ActionListener moAccionTerminada;


    public JCargaMasiva(JListDatos poList, String psCarga) throws CloneNotSupportedException{
        moList=poList;
        moErrores = new JListDatos(moList, false);
        msCarga=psCarga;
    }
    public void setAccionListenerTerminada(ActionListener poAccion){
        moAccionTerminada=poAccion;
    }

    public String getTitulo() {
        return "Carga masiva";
    }

    public int getNumeroRegistros() {
        return mlRegistros;
    }

    public void procesar() throws Throwable {

        masDatos = JFilaDatosDefecto.moArrayDatos(msCarga+'\n', '\n');
        mlRegistros = masDatos.length;
        for(mlRegistroActual=0; mlRegistroActual<masDatos.length; mlRegistroActual++){
            String[] lasFila = JFilaDatosDefecto.moArrayDatos(masDatos[mlRegistroActual]+'\t', '\t');
            JFilaDatosDefecto loFila = new JFilaDatosDefecto(lasFila);
            moList.addNew();
            moList.getFields().cargar(loFila);
            IResultado loResult = moList.update(true);
            if(!loResult.getBien()){
                moErrores.add(loFila);
            }
        }
        moAccionTerminada.actionPerformed(new ActionEvent(this, 0, msCarga));
        mbFin=true;
    }

    public String getTituloRegistroActual() {
        if(mlRegistroActual>=0 && masDatos!=null && mlRegistroActual<masDatos.length){
            return masDatos[mlRegistroActual];
        }else{
            return "";
        }
    }

    public void mostrarMensaje(String psMensaje) {
        if(moErrores.size()>0){
            utilesGUIx.msgbox.JMsgBox.mensajeError(null, "Hay errores");

            JSTabla loTabla = new JSTabla() {};
            loTabla.moList = moErrores;
            JBusqueda loBus = new JBusqueda(new JConsulta(loTabla, true), "Errores");
            try {
                JGUIxConfigGlobal.getInstancia().getMostrarPantalla().mostrarFormPrinci(loBus, 800, 600, JPanelGenerico.mclTipo ,JMostrarPantalla.mclEdicionFrame);
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }else{
            utilesGUIx.msgbox.JMsgBox.mensajeInformacion(null, psMensaje);
        }

    }




}
