/*
 * JFormConfigConexiones.java
 *
 * Created on 14 de marzo de 2008, 13:32
 */

package utilesGUIx.configForm.antig;

import utilesGUIx.configForm.JConexion;
import utilesGUIx.configForm.*;
import utilesGUIx.configForm.antig.JPanelPropiedades;
import java.awt.Frame;
import java.util.Enumeration;
import java.util.Properties;
import utiles.*;
import utiles.xml.dom.*;

public class JFormConfigConexiones extends javax.swing.JDialog {
    private JPanelPropiedades moPropiedades;
    private JConexion moConexionDirecta;
    private Element moListaRemotos;
    private JComunicacion moObjComu;
    
    /** Creates new form JFormConfigConexiones */
    public JFormConfigConexiones(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        moPropiedades = new JPanelPropiedades(true);
        moPropiedades.btnGuardar.setVisible(false);
        this.getContentPane().add(moPropiedades, java.awt.BorderLayout.CENTER);
    }
    
    public void setDatos(final JConexion poConexionDirecta, final Element poListaRemotos, final JComunicacion poObjComu ){
        moConexionDirecta = poConexionDirecta;
        moListaRemotos = poListaRemotos;
        moObjComu  = poObjComu;
        
        Properties loPropiedades = new Properties();
        IListaElementos loElem =  moListaRemotos.getChildren();
        for(int i = 0 ; i < loElem.size(); i++){
            Element loAux = (Element)loElem.get(i);
            loPropiedades.setProperty(loAux.getNombre(), loAux.getValor());
        }
        moPropiedades.setPropiedadesDefecto(loPropiedades);
        moPropiedades.refrescarTabla();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        btnConexionDirecta = new utilesGUIx.JButtonCZ();
        jButtonAceptar = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        btnConexionDirecta.setText("Conexion Directa");
        btnConexionDirecta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnConexionDirectaActionPerformed(evt);
            }
        });
        jPanel1.add(btnConexionDirecta);

        jButtonAceptar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/utilesGUIx/images/accept.gif"))); // NOI18N
        jButtonAceptar.setText("Aceptar");
        jButtonAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAceptarActionPerformed(evt);
            }
        });
        jPanel1.add(jButtonAceptar);

        jButtonCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/utilesGUIx/images/cancel.gif"))); // NOI18N
        jButtonCancelar.setText("Cancelar");
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });
        jPanel1.add(jButtonCancelar);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-463)/2, (screenSize.height-356)/2, 463, 356);
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAceptarActionPerformed
        try{
            //borramos todas las conexiones remotas
            while(moListaRemotos.hasChildren()){
                moListaRemotos.remove(0);
            }
            //aadimos todas las conexiones en propiedades
            Properties loPropiedades = moPropiedades.getPropiedades();
            for (Enumeration e = loPropiedades.propertyNames(); e.hasMoreElements();) {
                String key = (String)e.nextElement();
                String val = (String)loPropiedades.get(key);
                
                moListaRemotos.add(new Element(key, val));
            }
            moObjComu.moObjecto = new Boolean(true);
            dispose();
        }catch(Exception e){
            utilesGUIx.msgbox.JMsgBox.mensajeErrorYLog(this, e, getClass().getName());
        }
    }//GEN-LAST:event_jButtonAceptarActionPerformed

    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed
        try{
            moObjComu.moObjecto = new Boolean(false);
            dispose();
        }catch(Exception e){
            utilesGUIx.msgbox.JMsgBox.mensajeErrorYLog(this, e, getClass().getName());
        }
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    private void btnConexionDirectaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnConexionDirectaActionPerformed
        try{
            JFormConexion loConex = new JFormConexion(new Frame(), true, moConexionDirecta, true);
            loConex.setVisible(true);
        }catch(Exception e){
            utilesGUIx.msgbox.JMsgBox.mensajeErrorYLog(this, e, getClass().getName());
        }

    }//GEN-LAST:event_btnConexionDirectaActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        jButtonCancelarActionPerformed(null);
    }//GEN-LAST:event_formWindowClosing
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private utilesGUIx.JButtonCZ btnConexionDirecta;
    private javax.swing.JButton jButtonAceptar;
    private javax.swing.JButton jButtonCancelar;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
