/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utilesGUIx.controlProcesos;

import utiles.IListaElementos;
import utiles.JDepuracion;
import utiles.JListaElementos;
import utilesGUI.procesar.IProcesoAccion;

public class JProcesoManejador implements IProcesoThreadGroup {
    private IListaElementos moLista = new JListaElementos();
    private IListaElementos moListeners = new JListaElementos();
    
    public JProcesoManejador(){
    }
//    public synchronized void addProcesoSwingYEjecutar( final IProcesoAccion poProceso ) {
//        addProcesoSwingYEjecutar(poProceso,true);
//    }
//    public synchronized void addProcesoSwingYEjecutar(IProcesoAccion poProceso, boolean pbConMostrarForm) {
//        addProcesoYEjecutar(poProceso,pbConMostrarForm,true);
//    }
    public synchronized void addProcesoYEjecutar(final IProcesoAccion poProceso) {
        addProcesoYEjecutar(poProceso, true);
    }
    public synchronized void addProcesoYEjecutar(IProcesoAccion poProceso, boolean pbConMostrarForm) {
        addProcesoYEjecutar(poProceso, pbConMostrarForm, false);
    }
    private synchronized void addProcesoYEjecutar(IProcesoAccion poProceso, boolean pbConMostrarForm, boolean pbIsSwing) {
        JProcesoElemento loElem = new JProcesoElemento(poProceso,pbConMostrarForm, this);
//        if( pbIsSwing )
//            loElem.arrancarSwing();
//        else
            loElem.arrancar();
        moLista.add(loElem);
        llamarListeners();
    }

    synchronized void procesoFinalizado(JProcesoElemento poProcesoControl, Throwable moError){
        moLista.remove(poProcesoControl);
        llamarListeners();
        System.gc();
        JDepuracion.anadirTexto(
                JDepuracion.mclINFORMACION,
                getClass().getName(),
                "Memoria libre " + String.valueOf(Runtime.getRuntime().freeMemory())
                );

    }
    private void llamarListeners(){
        for(int i = 0 ; i < moListeners.size(); i++){
            IProcesoThreadGroupListener loLis = (IProcesoThreadGroupListener)moListeners.get(i);
            loLis.cambioProcesos(this);
        }
    }

    public IListaElementos getListaElementos() {
        return moLista;
    }
    public synchronized IListaElementos getListaProcesos() {
        IListaElementos loLista = new JListaElementos();
        for(int i = 0 ; i < moLista.size(); i++){
            JProcesoElemento loElem = (JProcesoElemento) moLista.get(i);
            loLista.add(loElem.getProceso());
        }
        return loLista;
    }
    public synchronized boolean isProcesosActivos(){
        return moLista.size()>0;
    }
    public synchronized int getProcesoTotal(){
        int lParte=0;
        int ltotal=0;
//        if(moLista.size()>0){
//            lParte = 90 / moLista.size();
//        }else{
//            lParte = 90;
//            ltotal=100;
//        }
        for(int i = 0; i < moLista.size(); i++){
            JProcesoElemento loControl = (JProcesoElemento)moLista.get(i);

            if(loControl.getProceso().getNumeroRegistros()<=0){
                ltotal+=10;
                lParte+=5;
            }else{
                lParte+=loControl.getProceso().getNumeroRegistro();
                ltotal+=loControl.getProceso().getNumeroRegistros();
            }
        }
        if(lParte>ltotal){
            lParte=ltotal;
        }
        if(moLista.size()==0){
            ltotal=100;
        }

        return  (int)((double)(lParte*100) / (double)ltotal);
    }

    public synchronized int getIndice(Object elemento){
        int lResult = -1;
        for(int i = 0; i < moLista.size() && lResult<0; i++){
            Object loControl = moLista.get(i);

            if(loControl==elemento){
                lResult=i;
            }
        }
        return lResult;
    }

    public void addListener(IProcesoThreadGroupListener poListener) {
        moListeners.add(poListener);
    }

    public void removeListener(IProcesoThreadGroupListener poListener) {
        moListeners.remove(poListener);
    }
    public static boolean isProcesosMostrarForm(IListaElementos poElementos){
        boolean lbMostrarForm = false;
        for(int i = 0; i < poElementos.size() && !lbMostrarForm; i++){
            JProcesoElemento loControl = (JProcesoElemento)poElementos.get(i);
            lbMostrarForm = loControl.isConMostrarForm();
        }
        return lbMostrarForm;
    }

    public synchronized String getProcesoTexto() {
        String lsResult = "";
        if(isProcesosActivos()){
            JProcesoElemento loControl = (JProcesoElemento)moLista.get(moLista.size()-1);
            String lsTitulo = loControl.getProceso().getTitulo();
            String lsTituloReg = loControl.getProceso().getTituloRegistroActual();
            if(lsTitulo.equalsIgnoreCase(lsTituloReg)){
                lsResult = lsTitulo;
            }else{
                lsResult = lsTitulo + " - " + lsTituloReg;
            }
            
        }

        return lsResult;

    }

}
