/*
 * JPanelGeneralFiltro.java
 *
 * Created on 5 de septiembre de 2005, 13:33
 */

package utilesGUIx.formsGenericos;

import java.awt.event.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import javax.swing.table.*;


import ListDatos.*;
import java.awt.Color;
import utilesGUIx.JTableCZSelecCeldas;
import utilesGUIx.JUtilTablaGUIx;

public class JPanelGeneralFiltro extends javax.swing.JPanel  implements ActionListener {
    public static final String mcsCambioFiltro = JPanelGenericoEvent.mcsCambioFiltro;

    private JListDatos moDatos;
    private boolean[] mabVisibles;
    private JTableModelFiltro moTableModel;
    private ActionListener moAccion;
    
    private boolean mbConOperadorComo =true;
    
    private JComboBox moComboBoxComparaciones; 
    private JComboBox moComboBoxUniones;
    private JTableCZSelecCeldas moSelect;
    private JTablaConfig moTablaConfig;
    /** Creates new form JPanelGeneralFiltro */
    public JPanelGeneralFiltro() {
        super();
        initComponents();
        moSelect = new JTableCZSelecCeldas(moTabla);
        
        moTabla.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    }
    public void setDatos(final JListDatos poDatos, final boolean[] pabVisibles, final ActionListener poAccion){
        setDatos(poDatos, pabVisibles, poAccion, true, null);
    }
    public void setDatos(final JListDatos poDatos, final boolean[] pabVisibles, final ActionListener poAccion, final boolean pbConOperadorComo){
        setDatos(poDatos, pabVisibles, poAccion, pbConOperadorComo, null);
    }
    public void setDatos(final JListDatos poDatos, final boolean[] pabVisibles, final ActionListener poAccion, final boolean pbConOperadorComo, final JTablaConfig poTablaConfig){
        moDatos = poDatos;
        moAccion = poAccion;
        mbConOperadorComo=pbConOperadorComo;
        mabVisibles = new boolean[moDatos.getFields().count()];
        moTablaConfig = poTablaConfig;
        
        crearCombos();
        
        setVisibles(pabVisibles);
    }
    private void crearCombos(){
        moComboBoxComparaciones = new JComboBox(); 
        if(mbConOperadorComo){
            moComboBoxComparaciones.addItem(JTableModelFiltro.mcsComo);
        }
        moComboBoxComparaciones.addItem(JTableModelFiltro.mcsIgual);
        moComboBoxComparaciones.addItem(JTableModelFiltro.mcsDistinto);
        moComboBoxComparaciones.addItem(JTableModelFiltro.mcsMayor);
        moComboBoxComparaciones.addItem(JTableModelFiltro.mcsMayorIgual);
        moComboBoxComparaciones.addItem(JTableModelFiltro.mcsMenor);
        moComboBoxComparaciones.addItem(JTableModelFiltro.mcsMenorIgual);
        moComboBoxComparaciones.addItem(JTableModelFiltro.mcsMasOMenos);
        
        moComboBoxUniones = new JComboBox(); 
        moComboBoxUniones.addItem(JTableModelFiltro.mcsY);
        moComboBoxUniones.addItem(JTableModelFiltro.mcsO);
    }
    
    public void setVisibles(final boolean[] pabVisibles){
        for(int i = 0 ; i < mabVisibles.length ; i++){
            if(pabVisibles!=null){
                mabVisibles[i] = pabVisibles[i];
            }else{
                mabVisibles[i] = true;
            }
        }
        mostrarTabla();
    }
    public JTableModelFiltro getTableModelFiltro(){
        return moTableModel;
    }
    //rellena la tabla
    private void mostrarTabla(){
        //creamos las filas de datos
        int lMax = 0;
        if(mabVisibles==null){
            lMax = moDatos.getFields().count();
        }else{
            for(int i = 0; i< mabVisibles.length; i++){
                if(mabVisibles[i]){
                    lMax++;
                }
            }
        }
        Object[][] data = new Object[lMax][6];
        boolean lbCampoValido = true;
        int lCampo = 0;
        for(int i = 0; i < moDatos.getFields().count(); i++ ){
            lbCampoValido = true;
            if(mabVisibles!=null){
                if(mabVisibles.length > i){
                    lbCampoValido=mabVisibles[i];
                }else{
                    lbCampoValido=false;
                }
            }
            if(lbCampoValido){
                String lsOperador =JTableModelFiltro.mcsComo;
                if(!mbConOperadorComo){
                    lsOperador =JTableModelFiltro.mcsIgual;
                }
                data[lCampo] = new Object[]{
                    new Integer(i), 
                    moDatos.getFields().get(i).getCaption(), 
                    lsOperador, 
                    "" , 
                    JTableModelFiltro.mcsY,
                    Boolean.FALSE
                    };
                lCampo++;
            }
        }
        // creamos el modelo de los datos
        if(moTableModel==null){
            moTableModel = new JTableModelFiltro(data, this);
        }else{
            moTableModel.setDatos(data);
        }
        moTabla.setModel(moTableModel);
        moTabla.setColorBackgroundDesac(Color.lightGray);
          
        // creamos los combos de las comparaciones
  
        TableColumn loColumn = moTabla.getColumn(JTableModelFiltro.mcsComparacion); 

        loColumn.setCellEditor(new DefaultCellEditor(moComboBoxComparaciones)); 
         
        // creamos los combos de las comparaciones
  
        loColumn = moTabla.getColumn(JTableModelFiltro.mcsUnion); 

        loColumn.setCellEditor(new DefaultCellEditor(moComboBoxUniones)); 
        
        //alto de fila
        moTabla.setRowHeight(20); 
        //ancho columnas
        setLongColumna(moTabla.getColumnModel().getColumn(JTableModelFiltro.mclCodigo), 0);
        setLongColumna(moTabla.getColumnModel().getColumn(JTableModelFiltro.mclNombre), 150);
        setLongColumna(moTabla.getColumnModel().getColumn(JTableModelFiltro.mclComparacion), 100);
        setLongColumna(moTabla.getColumnModel().getColumn(JTableModelFiltro.mclValor), 200);
        setLongColumna(moTabla.getColumnModel().getColumn(JTableModelFiltro.mclUnion), 40);
        setLongColumna(moTabla.getColumnModel().getColumn(JTableModelFiltro.mclDuplicadoSN), 0);

        moTabla.getSelectionModel().setSelectionInterval(0, 0);
        moTabla.setColumnSelectionInterval(JTableModelFiltro.mclValor, JTableModelFiltro.mclValor);
//        //color columna
//        DefaultTableCellRenderer colorRenderer = new DefaultTableCellRenderer() { 
// 	    public void setValue(Object value) { 
//                setBackground(new java.awt.Color(204,255,255));
//                setForeground(java.awt.Color.black); 
//                setText(value.toString());
// 	    } 
//         };
//        loColumn = moTabla.getColumn(JTableModelFiltro.mcsValor); 
//        loColumn.setCellRenderer(colorRenderer); 
    }
    private void setLongColumna(final TableColumn loColumn, final int plLong){
        if(plLong==0){
            loColumn.setMinWidth(plLong);
            loColumn.setPreferredWidth(plLong);
            loColumn.setWidth(plLong);
            loColumn.setMaxWidth(plLong);
        }else{
            loColumn.setPreferredWidth(plLong);
        }
    }
    /**
     *Limpia la tabla y el filtro y lo ejecuta
     */
    public void limpiar(){
        if(moTableModel!=null) {
            try{
                moTableModel.anularCambios();
                for(int i = 0; i< moTabla.getRowCount();i++){
                    moTableModel.setValueAt("", i, JTableModelFiltro.mclValor);
                    moTableModel.setValueAt(JTableModelFiltro.mcsComo, i, JTableModelFiltro.mclComparacion);
                    moTableModel.setValueAt(JTableModelFiltro.mcsY, i, JTableModelFiltro.mclUnion);

                }
    //            buscar();
            }finally{
                moTableModel.activarCambios();
            }
        }
    }
    /**
     * crea el filtro y lo ejecuta
     */
    public void buscar(){

        boolean lbRefrescar = false;
        //aplicamos el filtro
        if(moDatos.getFiltro().mbAlgunaCond()){
            moDatos.getFiltro().Clear();
            moDatos.filtrarNulo();
            lbRefrescar = true;
        }
        if(moTableModel.getFiltro()!=null && moTableModel.getFiltro().mbAlgunaCond()){
            moDatos.getFiltro().addCondicion(JListDatosFiltroConj.mclAND, moTableModel.getFiltro());
            moDatos.filtrar();
            lbRefrescar = true;
        }
        //llamamos al panel para que refresque
        if(moAccion!=null && lbRefrescar){
            moAccion.actionPerformed(new ActionEvent(this,0,mcsCambioFiltro));
        }
    }
    
    //cada vez que cambia una fila se llama a este evento y se ejecuta el filtrar
    public void actionPerformed(final ActionEvent e) {
//        if(!mbAnularEvento) {
            buscar();
            moTabla.repaint();
//        }
    }
    public void duplicar() throws Exception {
        if(moTabla.getSelectedRow()>=0){
            moTableModel.duplicar(moTabla.getSelectedRow());
        }else{
            throw new Exception("no existe la fila a duplicar");
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelBotones = new javax.swing.JPanel();
        jBtnLimpiar = new utilesGUIx.JButtonCZ();
        jBtnDuplicar = new utilesGUIx.JButtonCZ();
        jLabel1 = new javax.swing.JLabel();
        jBtnCopiarTabla = new utilesGUIx.JButtonCZ();
        jScrollPane2 = new javax.swing.JScrollPane();
        moTabla = new utilesGUIx.JTableCZ();

        setLayout(new java.awt.BorderLayout());

        jPanelBotones.setBackground(new java.awt.Color(175, 181, 186));
        jPanelBotones.setOpaque(false);
        jPanelBotones.setLayout(new java.awt.GridLayout(4, 0));

        jBtnLimpiar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/utilesGUIx/images/RowDelete16.gif"))); // NOI18N
        jBtnLimpiar.setText("Limpiar ");
        jBtnLimpiar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBtnLimpiarActionPerformed(evt);
            }
        });
        jPanelBotones.add(jBtnLimpiar);

        jBtnDuplicar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/utilesGUIx/images/RowInsertAfter16.gif"))); // NOI18N
        jBtnDuplicar.setText("Duplicar");
        jBtnDuplicar.setToolTipText("<html>Duplica la linea actual del filtro,<br> para poder hacer 2 filtros<br> por el mismo campo</html>");
        jBtnDuplicar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBtnDuplicarActionPerformed(evt);
            }
        });
        jPanelBotones.add(jBtnDuplicar);
        jPanelBotones.add(jLabel1);

        jBtnCopiarTabla.setIcon(new javax.swing.ImageIcon(getClass().getResource("/utilesGUIx/images/Copy16.gif"))); // NOI18N
        jBtnCopiarTabla.setText("Copiar  T.");
        jBtnCopiarTabla.setToolTipText("Copiar la tabla de datos completa");
        jBtnCopiarTabla.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBtnCopiarTablaActionPerformed(evt);
            }
        });
        jPanelBotones.add(jBtnCopiarTabla);

        add(jPanelBotones, java.awt.BorderLayout.EAST);

        jScrollPane2.setBackground(new java.awt.Color(237, 234, 229));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(100, 100));

        moTabla.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        moTabla.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        moTabla.setColumnSelectionAllowed(true);
        moTabla.setNextFocusableComponent(jBtnDuplicar);
        jScrollPane2.setViewportView(moTabla);

        add(jScrollPane2, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jBtnDuplicarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBtnDuplicarActionPerformed
        try{
            duplicar();
            moTabla.validate();
            moTabla.repaint();
        }catch(Exception e){
            utilesGUIx.msgbox.JMsgBox.mensajeErrorYLog(this, e, getClass().getName());
        }
    }//GEN-LAST:event_jBtnDuplicarActionPerformed

    private void jBtnLimpiarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBtnLimpiarActionPerformed
        limpiar();
        moTabla.repaint();
    }//GEN-LAST:event_jBtnLimpiarActionPerformed

    private void jBtnCopiarTablaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBtnCopiarTablaActionPerformed
        try {
            JListDatos loList = JPanelGenericoAbstract.getListOrdenado(
                    moDatos
                    , moTablaConfig.getConfigTablaConcreta());        
            loList.msTabla = moDatos.msTabla;
            JUtilTablaGUIx.copiar(loList);
        }catch(Exception e){
            utilesGUIx.msgbox.JMsgBox.mensajeErrorYLog(this, e, getClass().getName());
        }
        
    }//GEN-LAST:event_jBtnCopiarTablaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public utilesGUIx.JButtonCZ jBtnCopiarTabla;
    private utilesGUIx.JButtonCZ jBtnDuplicar;
    private utilesGUIx.JButtonCZ jBtnLimpiar;
    private javax.swing.JLabel jLabel1;
    public javax.swing.JPanel jPanelBotones;
    private javax.swing.JScrollPane jScrollPane2;
    private utilesGUIx.JTableCZ moTabla;
    // End of variables declaration//GEN-END:variables
    
}

