/*
 * JBotonTactil.java
 *
 * Created on 19 de enero de 2007, 12:40
 */

package utilesGUIx.imgTrata.lista;

import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.net.URL;
import utiles.IListaElementos;
import utiles.JDepuracion;
import utiles.JListaElementos;

public class JBotonControl extends javax.swing.JPanel implements java.awt.event.MouseListener, java.awt.event.ActionListener {
    
    private String msNombre="";
    
    private final IListaElementos moActionListener;
    
    /** Creates new form JBotonTactil */
    public JBotonControl() {
        super();
        initComponents();
        moActionListener = new JListaElementos();
    }
    
    public void addActionListener(final ActionListener poElem){
        moActionListener.add(poElem);
    }
    private void llamarListeners(){
        ActionEvent loEvent = new ActionEvent(this,0,getNombre());
        for(int i = 0; i < moActionListener.size(); i++){
            ActionListener l =( ActionListener)moActionListener.get(i);
            l.actionPerformed(loEvent);
        }
    }
    public String getNombre(){
        return msNombre;
    }
    public void setNombre(final String psValor){
        msNombre = psValor;
    }
    
    public void setImage(final String psImagen){
        try{
            
            if(psImagen !=null && !psImagen.equals("")){
                javax.swing.ImageIcon loIcon = null;
                File loFile = new File(psImagen);
                if(loFile.exists()){
                    loIcon = new javax.swing.ImageIcon(psImagen);
                }
                if(loIcon == null){
                    URL loUrl = getClass().getResource(psImagen);
                    if(loUrl!=null){
                        loIcon = new javax.swing.ImageIcon(loUrl);
                    }
                }
                if(loIcon == null){
                    loIcon = new javax.swing.ImageIcon(new URL(psImagen));
                }
                btnImagen.setIcon(loIcon);
            }
            
        }catch(Exception e){
            JDepuracion.anadirTexto(getClass().getName(), e);
        }
    }
    
    public void setText(final String psTexto){
        lblTexto.setText(psTexto);
        lblTexto.setToolTipText(psTexto);
        btnImagen.setToolTipText(psTexto);
//        btnImagen.setVisible(psTexto != null && psTexto.compareTo("")!=0 );
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btnImagen = new utilesGUIx.JButtonCZ();
        lblTexto = new utilesGUIx.JLabelCZ();

        setMaximumSize(new java.awt.Dimension(100, 100));
        setMinimumSize(new java.awt.Dimension(100, 100));
        setOpaque(false);
        setPreferredSize(new java.awt.Dimension(100, 100));
        setLayout(new java.awt.GridBagLayout());

        btnImagen.setMaximumSize(null);
        btnImagen.setMinimumSize(null);
        btnImagen.setPreferredSize(null);
        btnImagen.addActionListener(this);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(btnImagen, gridBagConstraints);

        lblTexto.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblTexto.setText("jLabel2");
        lblTexto.setFont(new java.awt.Font("Dialog", 0, 10));
        lblTexto.addMouseListener(this);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(lblTexto, gridBagConstraints);
    }

    // Code for dispatching events from components to event handlers.

    public void actionPerformed(java.awt.event.ActionEvent evt) {
        if (evt.getSource() == btnImagen) {
            JBotonControl.this.btnImagenActionPerformed(evt);
        }
    }

    public void mouseClicked(java.awt.event.MouseEvent evt) {
        if (evt.getSource() == lblTexto) {
            JBotonControl.this.lblTextoMouseClicked(evt);
        }
    }

    public void mouseEntered(java.awt.event.MouseEvent evt) {
    }

    public void mouseExited(java.awt.event.MouseEvent evt) {
    }

    public void mousePressed(java.awt.event.MouseEvent evt) {
    }

    public void mouseReleased(java.awt.event.MouseEvent evt) {
    }// </editor-fold>//GEN-END:initComponents

    private void btnImagenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnImagenActionPerformed
        llamarListeners();
    }//GEN-LAST:event_btnImagenActionPerformed

    private void lblTextoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lblTextoMouseClicked
        btnImagen.doClick();
    }//GEN-LAST:event_lblTextoMouseClicked
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private utilesGUIx.JButtonCZ btnImagen;
    private utilesGUIx.JLabelCZ lblTexto;
    // End of variables declaration//GEN-END:variables
    
}
