/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utilesGUIx.imgTrata.lista;

import ListDatos.IFilaDatos;
import java.io.File;
import java.net.URL;
import javax.swing.ImageIcon;
import utiles.JDepuracion;
import utilesGUIx.imgTrata.JIMGTrata;
import utilesGUIx.imgTrata.JVISTAPRELIMINAR;

/**
 *
 * @author eduardo
 */
public class JImagenBasica implements IImagen {
    private final int mlDescrip;
    private final int mlImagen;
    private IFilaDatos moFila;
    private ImageIcon moIcon;
    private String msRutaBase;

    public JImagenBasica(int plImagen, int plDescrip){
        mlImagen = plImagen;
        mlDescrip = plDescrip;
        moIcon=null;
    }
    public JImagenBasica(int plImagen, int plDescrip, String psRutaBase){
        this(plImagen, plDescrip);
        msRutaBase = psRutaBase;
    }

    public synchronized void setDatos(IFilaDatos poFila) throws Throwable {
        moFila = poFila;
        moIcon=null;
        if( moFila !=null && !moFila.msCampo(mlImagen).equals("")){
            String lsImagen = moFila.msCampo(mlImagen);
            if(msRutaBase!=null && !msRutaBase.equals("")){
                lsImagen = msRutaBase + lsImagen;
            }
            moIcon = null;
            File loFile = new File(lsImagen);
            if(loFile.exists()){
                moIcon = JIMGTrata.getIMGTrata().getImagenCargada(lsImagen);
            }
            if(moIcon == null){
                URL loUrl = getClass().getResource(lsImagen);
                if(loUrl!=null){
                    moIcon = new javax.swing.ImageIcon(loUrl);
                    JIMGTrata.getIMGTrata().imagenEsperar(moIcon.getImage());
                }
            }
            if(moIcon == null){
                try{
                    moIcon = new javax.swing.ImageIcon(new URL(lsImagen));
                    JIMGTrata.getIMGTrata().imagenEsperar(moIcon.getImage());
                }catch(Throwable e){
                    JDepuracion.anadirTexto(getClass().getName() , e);
                }
            }
        }
    }

    public ImageIcon getImagen() {
        return moIcon;
    }

    public String getDescripcion() {
        if( moFila !=null ){
            return moFila.msCampo(mlDescrip);
        }else{
            return "";
        }
    }

    public void ver() throws Throwable {
        JVISTAPRELIMINAR loVista = new JVISTAPRELIMINAR();
        loVista.setImagen(moIcon.getImage(), getDescripcion());
        loVista.setVisible(true);
    }

}
