/*
 * JFormLookAndFeel1.java
 *
 * Created on 3 de enero de 2006, 13:15
 */

package utilesGUIx.lookAndFeel;

import ListDatos.IFilaDatos;
import javax.swing.*;

import utiles.IListaElementos;
import utiles.JDepuracion;

public class JFormLookAndFeel extends javax.swing.JDialog {
    JLookAndFeel moPadre;
    
    /** Creates new form JFormLookAndFeel1 */
    public JFormLookAndFeel(java.awt.Frame parent, boolean modal,JLookAndFeel poPadre) {
        super(parent, modal);
        initComponents();
        moPadre = poPadre;
        rellenarPantalla();
        
    }
    private void rellenarPantalla(){
        cmbEstilo.borrarTodo();
        cmbTema.borrarTodo();
        IListaElementos loEstilos = moPadre.getEstilos();
        int i = 0;
        for(i = 0; i < loEstilos.size(); i++){
            JLookAndFeelEstilo look = (JLookAndFeelEstilo)loEstilos.get(i);
            cmbEstilo.addLinea(look.msCaption, String.valueOf(i));
        }
        
    }

    private void rellenarTema(){
        cmbTema.borrarTodo();
        cmbTema.addLinea("","");
        JLookAndFeelEstilo loEstilo = (JLookAndFeelEstilo)moPadre.getEstilos().get(Integer.parseInt(cmbEstilo.getFilaActual().msCampo(0)));
        IListaElementos loTemas = loEstilo.moTemas;
        int i = 0;
        for(i = 0; i < loTemas.size(); i++){
            IFilaDatos loTema = (IFilaDatos)loTemas.get(i);
            cmbTema.addLinea(loTema.msCampo(JLookAndFeelEstilo.mclCaption), String.valueOf(i));
        }
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        cmbEstilo = new utilesGUIx.JComboBoxCZ();
        jLabel2 = new javax.swing.JLabel();
        cmbTema = new utilesGUIx.JComboBoxCZ();
        jPanel1 = new javax.swing.JPanel();
        btnAceptar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("Estilo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        cmbEstilo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cmbEstilo.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cmbEstiloItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        getContentPane().add(cmbEstilo, gridBagConstraints);

        jLabel2.setText("Tema");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        cmbTema.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        getContentPane().add(cmbTema, gridBagConstraints);

        btnAceptar.setText("Aceptar");
        btnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAceptarActionPerformed3(evt);
            }
        });
        jPanel1.add(btnAceptar);

        btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed3(evt);
            }
        });
        jPanel1.add(btnCancelar);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.weighty = 0.1;
        getContentPane().add(jPanel1, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-417)/2, (screenSize.height-119)/2, 417, 119);
    }// </editor-fold>//GEN-END:initComponents


    private void cmbEstiloItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cmbEstiloItemStateChanged
        try{
            rellenarTema();
        }catch(Exception e){
            
        }
    }//GEN-LAST:event_cmbEstiloItemStateChanged

    private void btnCancelarActionPerformed3(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed3
        dispose();
    }//GEN-LAST:event_btnCancelarActionPerformed3

    private void btnAceptarActionPerformed3(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAceptarActionPerformed3
        try{
            int lEstilo = Integer.parseInt(cmbEstilo.getFilaActual().msCampo(0));
            JLookAndFeelEstilo loEstilo = (JLookAndFeelEstilo)moPadre.getEstilos().get(lEstilo);
            moPadre.setEstilo(loEstilo);
            try{
                int lTema = Integer.parseInt(cmbTema.getFilaActual().msCampo(0));
                IFilaDatos loTema = (IFilaDatos)loEstilo.moTemas.get(lTema);
                moPadre.setTema(loTema);
            }catch(Exception e){
                //vacio
            }
            dispose();
        }catch(Exception e){
           utilesGUIx.msgbox.JMsgBox.mensajeErrorYLog(this, e, getClass().getName());
        }
    }//GEN-LAST:event_btnAceptarActionPerformed3
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAceptar;
    private javax.swing.JButton btnCancelar;
    private utilesGUIx.JComboBoxCZ cmbEstilo;
    private utilesGUIx.JComboBoxCZ cmbTema;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
