/*
 * JConsulta.java
 *
 * Created on 27 de octubre de 2004, 9:14
 */

package utilesGUIx.panelesGenericos;

import utilesGUIx.formsGenericos.busqueda.*;
import ListDatos.*;

/**Consulta para buscar*/
public class JConsulta implements IConsulta {
    private final JSTabla moTabla;
    private final boolean mbConDatos;
    /**
     * Creates a new instance of JConsulta
     * @param poTabla datos
     */
    public JConsulta(JSTabla poTabla, boolean pbConDatos) {
        moTabla=poTabla;
        mbConDatos = pbConDatos;
    }

    public void addFilaPorClave(IFilaDatos poFila) throws Exception {
        switch(poFila.getTipoModif()){
            case JListDatos.mclBorrar:
                moTabla.moList.borrar(false);
                break;
            case JListDatos.mclEditar:
                moTabla.moList.getFields().cargar(poFila);
                moTabla.moList.update(false);
                break;
            case JListDatos.mclNuevo:
                moTabla.moList.addNew();
                moTabla.moList.getFields().cargar(poFila);
                moTabla.moList.update(false);
                break;
        }
    }

    public ListDatos.JListDatos getList() {
        return moTabla.moList;
    }

    public void refrescar(boolean pbPasarACache, boolean pbLimpiarCache) throws Exception {
        if(!mbConDatos || pbLimpiarCache) {
            moTabla.recuperarTodos(pbPasarACache, false, pbLimpiarCache);
        }
    }

    public boolean getPasarCache() {
        return false;
    }
    
}
