/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utilesGUIx.plugin.seguridad;

import ListDatos.ECampoError;
import ListDatos.JListDatos;
import java.awt.Component;
import java.awt.Container;
import javax.swing.AbstractButton;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import utiles.IListaElementos;
import utiles.JDepuracion;
import utiles.JListaElementos;
import utilesGUIx.JGUIxConfigGlobal;
import utilesGUIx.plugin.*;
import utilesGUIx.formsGenericos.*;
import utilesGUIx.formsGenericos.boton.IBotonRelacionado;
import utilesGUIx.plugin.toolBar.IComponenteAplicacion;

public class JPlugInSeguridadPermisosBase {
    public static final String mcsTablas = "Tablas";
    public static final String mcsControlador = "Listado";
    public static final String mcsFrame = "Ficha";
    public static final String mcsFramePrincipal = "Principal";
    public static final String mcsEditar = "Editar";
    public static final String mcsNuevo = "Nuevo";
    public static final String mcsBorrar = "Borrar";

    private IListaElementos moLista;
    
    public JPlugInSeguridadPermisosBase (){
        moLista = new JListaElementos();
    }

    public IListaElementos getLista(){
        return moLista;
    }
    public void addTabla(final String psTabla){
        moLista.add(psTabla);
    }
    public void addControlador(final IPanelControlador poControlador){
        JGUIxConfigGlobal.getInstancia().getPlugInFactoria().getPlugInManager().procesarControlador(
                JGUIxConfigGlobal.getInstancia().getPlugInFactoria().getPlugInContexto(),
                poControlador
                );
        moLista.add(poControlador);
    }
    public void addFrame(final IPlugInFrame poFrame){
        JGUIxConfigGlobal.getInstancia().getPlugInFactoria().getPlugInManager().procesarEdicion(
                JGUIxConfigGlobal.getInstancia().getPlugInFactoria().getPlugInContexto(),
                poFrame
                );
        moLista.add(poFrame);
    }
    public void addConsulta(final IPlugInConsulta poFrame){
        JGUIxConfigGlobal.getInstancia().getPlugInFactoria().getPlugInManager().procesarConsulta(
                JGUIxConfigGlobal.getInstancia().getPlugInFactoria().getPlugInContexto(),
                poFrame
                );
        moLista.add(poFrame);
    }

    public JTPlugInListaPermisos getListaPermisosBase() throws ECampoError{
        JTPlugInListaPermisos loPermisos = new JTPlugInListaPermisos();

        for(int i = 0 ; i < moLista.size(); i++){
            Object loObj = moLista.get(i);
            if(loObj instanceof IPanelControlador){
                IPanelControlador loPanelControlador = (IPanelControlador) loObj;
                rellenarPermisos(loPermisos, loPanelControlador);
            } else if(loObj instanceof IPlugInConsulta){
                IPlugInConsulta loPlugFrame = (IPlugInConsulta) loObj;
                rellenarPermisosC(loPermisos, loPlugFrame);
                //OJO: falta los propios de la consulta

            } else if(loObj instanceof IPlugInFrame){
                IPlugInFrame loPlugFrame = (IPlugInFrame) loObj;
                rellenarPermisos(loPermisos, loPlugFrame);
            } else if(loObj instanceof String){
                rellenarPermisos(loPermisos, (String)loObj);
            }

        }

        return loPermisos;
    }

    private static void rellenarPermisos(JTPlugInListaPermisos poPermisos, IPlugInFrame poFrame, IListaElementos poBotones) throws ECampoError {
        for(int lb = 0 ; lb < poBotones.size(); lb++){
            IComponenteAplicacion loComp = (IComponenteAplicacion) poBotones.get(lb);
            addPermisoSiAccion(
                    poPermisos,
                    poFrame.getIdentificador(),
                    getIdenbotnito(poFrame),
                    loComp.getNombre());
            if(loComp.getListaBotones()!=null){
                rellenarPermisos(poPermisos, poFrame, loComp.getListaBotones());
            }
        }
        
    }
    private static void rellenarPermisos(JTPlugInListaPermisos poPermisos, String psTabla) throws ECampoError {
        addPermiso(poPermisos, mcsTablas, mcsTablas, psTabla + "." + mcsEditar);
        addPermiso(poPermisos, mcsTablas, mcsTablas, psTabla + "." + mcsNuevo);
        addPermiso(poPermisos, mcsTablas, mcsTablas, psTabla + "." + mcsBorrar);
    }
    private static void addPermisoSiAccion(JTPlugInListaPermisos poPermisos, String psObjeto, String psCaption, String psAccion) throws ECampoError {
        if(psAccion!=null && !psAccion.equals("")){
            addPermiso(poPermisos, psObjeto, psCaption, psAccion);
        }

    }
    private static void addPermiso(JTPlugInListaPermisos poPermisos, String psObjeto, String psCaption, String psAccion) throws ECampoError {
        if(!poPermisos.moList.buscar(JListDatos.mclTIgual , new int[] {
                poPermisos.lPosiOBJETO, poPermisos.lPosiACCION
            }, new String[]{
                psObjeto, psAccion
            })){
                poPermisos.moList.addNew();
                poPermisos.getOBJETO().setValue(psObjeto);
                poPermisos.getCAPTIONOBJETO().setValue(psCaption);
                poPermisos.getACCION().setValue(psAccion);
                poPermisos.getACTIVOSN().setValue(true);
                poPermisos.moList.update(false);
        }
    }
    public static void rellenarPermisos(JTPlugInListaPermisos poPermisos, IPanelControlador loPanelControlador) throws ECampoError {
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), "");
        for(int lB = 0 ; lB < loPanelControlador.getParametros().getBotonesGenerales().getListaBotones().size(); lB++){
            IBotonRelacionado loBoton = (IBotonRelacionado) loPanelControlador.getParametros().getBotonesGenerales().getListaBotones().get(lB);
            addPermisoSiAccion(poPermisos, loPanelControlador.getClass().getName(), mcsControlador + loPanelControlador.getParametros().getNombre(), loBoton.getNombre());
        }
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsAceptar);
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsBorrar);
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsCancelar);
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsCopiarTabla);
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsEditar);
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsFiltro);
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsNuevo);
        addPermiso(poPermisos, loPanelControlador.getClass().getName(), mcsControlador +  loPanelControlador.getParametros().getNombre(), JPanelGeneralBotones.mcsRefrescar);
    }
    public static void rellenarPermisosC(JTPlugInListaPermisos poPermisos, IPlugInConsulta poFrame) throws ECampoError {
        rellenarPermisos(poPermisos, (IPlugInFrame)poFrame);
    }

    public static String getIdenbotnito(IPlugInFrame poObjeto){
        String lsIdentB = "";
        String psIdent = poObjeto.getIdentificador();
        int i = psIdent.length()-1;
        while(i>=0 && psIdent.charAt(i)!='.'){
            lsIdentB=psIdent.charAt(i)+lsIdentB;
            i--;
        }

        if(poObjeto instanceof IPlugInFrame){
            lsIdentB = mcsFrame + " " + lsIdentB;
        }


        return lsIdentB;
    }
    public static void rellenarPermisos(JTPlugInListaPermisos poPermisos, IPlugInFrame poPlugFrame) throws ECampoError {
        addPermiso(poPermisos, poPlugFrame.getIdentificador(), getIdenbotnito(poPlugFrame), "");
        rellenarPermisos(poPermisos, poPlugFrame, poPlugFrame.getListaComponentesAplicacion().getListaBotones());

    }

    public static void rellenarPermisos(JTPlugInListaPermisos poPermisos, String psObjeto, String psObjCaption, JMenu poMenu) throws ECampoError {
        for(int i = 0 ; i < poMenu.getMenuComponentCount(); i++){
            Component loComp = poMenu.getMenuComponent(i);
            if(loComp!=null){
                if(loComp instanceof JMenu){
                    addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, ((JMenu)loComp).getActionCommand());
                    rellenarPermisos(poPermisos, psObjeto, psObjCaption, ((JMenu)loComp));
                }else if(loComp instanceof JMenuItem){
                    addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, ((JMenuItem)loComp).getActionCommand());
                } else{
                    addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, loComp.getName());
                }
            }
        }
    }
    public static void rellenarPermisos(JTPlugInListaPermisos poPermisos, String psObjeto, String psObjCaption, JPopupMenu poMenuPop) throws ECampoError {
        for(int i = 0 ; i < poMenuPop.getComponentCount(); i++){
            Component loComp = poMenuPop.getComponent(i);
            if(loComp instanceof JMenu){
                addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, ((JMenu)loComp).getActionCommand());
                rellenarPermisos(poPermisos, psObjeto, psObjCaption, ((JMenu)loComp));
            }else if(loComp instanceof AbstractButton){
                addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, ((AbstractButton)loComp).getActionCommand());
            } else{
                JDepuracion.anadirTexto(JPlugInSeguridadPermisosBase.class.getName(), "Componente popup menu desconocido " + loComp.getClass().getName());
            }
        }        
    }
    public static void rellenarPermisos(JTPlugInListaPermisos poPermisos, String psObjeto, String psObjCaption, Container poContainer) throws ECampoError {
        for(int i = 0 ; i < poContainer.getComponentCount(); i++){
            Component loComp = poContainer.getComponent(i);
            if(loComp instanceof JMenu){
                addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, ((JMenu)loComp).getActionCommand());
                rellenarPermisos(poPermisos, psObjeto, psObjCaption, ((JMenu)loComp));
            }else if(loComp instanceof AbstractButton){
                addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, ((AbstractButton)loComp).getActionCommand());
            }else if(loComp instanceof Container){
                addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, loComp.getName());
                rellenarPermisos(poPermisos, psObjeto, psObjCaption, ((Container)loComp));
            }else {
                addPermisoSiAccion(poPermisos, psObjeto, psObjCaption, loComp.getName());
            }
        }        
    }
    


}
